// ConsoleApp.h: CConsoleApp NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CONSOLEAPP_H__94D9030A_D9A3_46D8_848C_DA16DE7AD40D__INCLUDED_)
#define AFX_CONSOLEAPP_H__94D9030A_D9A3_46D8_848C_DA16DE7AD40D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <stdio.h>
#include <stdarg.h>
#include <io.h>
#include <stddef.h>
#include <stdlib.h>
#include <string.h>
#include <direct.h>
#include <fcntl.h>
#include <mbctype.h>
#include <sys/types.h>
#include <sys/stat.h>

#include <cstdlib>
#include <complex>

#include "Common.h"

using namespace std;

class CDeps
{
public:
	static char *strerror( int errnum )
	{
		return ::strerror(errnum);
	};
	static char *strerror( const char *string )
	{
		return ::_strerror(string);
	};

	static int printf(const char *format ...)
	{
		va_list ap;
		va_start(ap, format);
		vprintf(format, ap);
		va_end(ap);
		return 0;
	};
	static int vmprintf(FILE *pfout, const char *format, va_list ap)
	{
		vprintf(format, ap);
		if(pfout) 
		{
			vfprintf(pfout, format, ap);
			fflush(pfout);
		}
		if(pfout) return 1;
		return 0;
	};
	static int mprintf(FILE *pfout, const char *format ...)
	{
		va_list ap;
		va_start(ap, format);
		int ret = vmprintf(pfout, format, ap);
		va_end(ap);
		return ret;
	};
	static int wprintf(FILE *pfout, const char *format ...)
	{
		va_list ap;
		va_start(ap, format);
		if(pfout) 
		{
			vfprintf(pfout, format, ap);
			fflush(pfout);
		}
		va_end(ap);
		if(pfout) return 1;
		return 0;
	};
	static char *bfgets(char *string, int n, FILE *stream)
	{
		char *cp = fgets(string, n, stream);
	
		int i = 0;
		int len = strlen(string);
		for(char *c = string ; *c != 0 ; c++, i++)
		{
			if(*c == 0x1b) continue;
			if(_ismbblead(*c) && _ismbbtrail(*(c+1))) continue;
			if( i > 0 &&
			   (_ismbblead(*(c-1)) && _ismbbtrail(*c))) continue;

			if(*c == '\r' || *c == '\n')
			{
				*c = '\n';
				c++;
				if(!(*c == '\r' || *c == '\n') &&
				 len+1 >= n)
				{
					char s[10];
					fgets(s, 10, stream);
				}
				*c = 0;
				break;
			}
			else if(*c < ' ') *c = ' ';
		}
		return cp;
	};
	static char *bfprintf(FILE *stream, char * /*format*/, char *str)
	{
		char *cp = str;

		for( ; *cp != 0 ; cp++)
		{
			putc(*cp, stream);
			if(*cp == '\n') putc('\r', stream);
		}
		return str;
	};

	static struct _stat& GetFileStatus(const char* fname, struct _stat& st)
	{
		_stat(fname, &st);
		return st;
	};
	static time_t& GetFileTimeStamp(const char* fname)
	{
		struct _stat st;
		_stat(fname, &st);
//		printf( "XV         : %s", ctime( &buf.st_atime ) );
		return st.st_ctime;
	};
	static long GetFileSize(const char* fname)
	{
		int hsrc;
		if((hsrc = open(fname, _O_RDONLY)) <= 0) return 0;
		long SourceSize = filelength(hsrc);
		close(hsrc);
		return SourceSize;
	};
	static long GetFileLength(const char* fname)
	{
		return GetFileSize(fname);
	};
	static bool IsFileExist(const char *filename)
	{
		FILE *fp;
		if((fp = fopen(filename, "r")) == NULL) return false;
		fclose(fp);
		return true;
	};
	static void ChangeDir(char *directory)
	{
		char c;

		if(directory[1] == ':')
		{
			c = directory[0];
			if('a' <= c && c <= 'z') c -= 'a';
			else if('A' <= c && c<= 'Z') c -= 'A';
			else
			{
				_chdir(directory);
				return;
			}	
			_chdrive(c);
		}
		_chdir(directory);
	};
	static int ConvertToValidFileName(char* filename)
	{
		char* cp = filename;
		for( ; *cp != 0 ; cp++)
		{
			if(strchr(":/\\", *cp) != 0)
			{
				if(_ismbblead(*cp) && _ismbbtrail(*(cp+1))) continue;
				else if(_ismbblead(*(cp-1)) && _ismbbtrail(*cp)) continue;
				*cp = '-';
			}
		}
		return 1;
	};
	static bool IsMatchFile(const char* filename, const char* mask)
	{
		char *cp1 = strrchr(filename, '.');
		char *cp2 = strrchr(mask, '.');
		if(cp1 == NULL) cp1 = "";
		if(cp2 == NULL) cp2 = "";
		if(stricmp(cp1, cp2) == 0) return true;
		return false;
	};
	static bool IsMatchFileWithMasks(const char* filename, const char* FileMasks)
	{
		char filemask[256];
		strcpy(filemask, FileMasks);
		char *cp = filemask;
		char *cp1;
		while(1)
		{
			cp1 = strchr(cp, ';');
			if(cp1) *cp1 = 0;
			if(*cp != 0 && IsMatchFile(filename, cp)) return true;
			if(cp1 == NULL) break;
			cp = cp1+1;
		}
		return false;
	};

	static string& MakePath(string& path, const char* dir, const char* fname)
	{
		if(*dir == 0) 
		{
			path = fname;
			return path;
		}
		const char *cp = dir + strlen(dir) - 1;
		if(*cp == '\\') path = (string)dir + fname;
		else path = (string)dir + '\\' + fname;
		return path;
	};
	static char *MakePath(char *path, const char* dir, const char* fname)
	{
		string s = path;
		MakePath(s, dir, fname);
		strcpy(path, s.c_str());
		return path;
	};
	static const char *ExtractDirectory(const char* path, char* dirpath, bool AddDrive = true)
	{
		char drive[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], ext[_MAX_EXT];
		_splitpath(path, drive, dir, fname, ext);
		if(AddDrive) _makepath(dirpath, drive, dir, "", "");
		else strcpy(dirpath, dir);
		return dirpath;
	};
	static const char* ExtractDirectory(const char* path, string& str)
	{
		char s[_MAX_PATH];
		const char* ret = ExtractDirectory(path, s);
		str = s;
		return str.c_str();
	};
	static const char* ExtractDrive(char *fpath, char *drive)
	{
		char dir[_MAX_DIR], fname[_MAX_FNAME], ext[_MAX_EXT];
		_splitpath(fpath, drive, dir, fname, ext);
		return drive;
	};
	static const char *ExtractFileName(const char* path, char* filename, bool WithExtention = true)
	{
		char drive[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], ext[_MAX_EXT];
		_splitpath(path, drive, dir, fname, ext);
		if(WithExtention)
			_makepath(filename, "", "", fname, ext);
		else
			_makepath(filename, "", "", fname, "");
		return filename;
	};
	static const char *ReplaceExtention(char* path, const char* newext)
	{
		char drive[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], ext[_MAX_EXT];
		_splitpath(path, drive, dir, fname, ext);
		_makepath(path, drive, dir, fname, newext);
		return path;
	};
	static const char* ReplaceExtention(string& fpath, const char* newext)
	{
		char path[_MAX_PATH];
		char drive[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], ext[_MAX_EXT];
		_splitpath(fpath.c_str(), drive, dir, fname, ext);
		_makepath(path, drive, dir, fname, newext);
		fpath = path;
		return fpath.c_str();
	};
	static string& GetExtention(const char* path, string &ext)
	{
		char drive[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], e[_MAX_EXT];
		_splitpath(path, drive, dir, fname, e);
		return ext = e;
	};
	static const char *GetExtention(const char* path, char* ext)
	{
		char drive[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME];
		_splitpath(path, drive, dir, fname, ext);
		return ext;
	};
	static const char* ReplaceFileName(const char* path, const char* newfilename, string& dest)
	{
		string dir;
		ExtractDirectory(path, dir);
		MakePath(dest, dir.c_str(), newfilename);
		return dir.c_str();
	};
	static const char* ExtractFileName(const char* path, string& filename, bool WithExtention = true)
	{
		char fn[_MAX_PATH];
		ExtractFileName(path, fn, WithExtention);
		filename = fn;
		return filename.c_str();
	};
};

class CConsoleApp : public CDeps
{
public:
	FILE *in;
	FILE *out;
	char InputFilePath[MAX_FILEPATH];
	char OutputFilePath[MAX_FILEPATH];
	char AppName[MAX_FILEPATH];

	CConsoleApp()
	{
		in  = NULL;
		out = NULL;
		sprintf(InputFilePath,  "Input.in");
		sprintf(OutputFilePath,  "Input.out.txt");
	};
	~CConsoleApp()
	{
		CloseFiles();
	};

	int Die(int ret)
	{
		if(errno > 0)
			mprintf(out, "Last system error: %s (%d)\n", strerror(errno), errno);
		exit(ret);
	};
	int Do(int argn, char *argv[])
	{
		return Do(argn, argv, NULL);
	};
	int Do(int argn, char *argv[], const char *TitleMessage[])
	{
		ExtractFileName(argv[0], AppName, false);
//******************************************
// vO^CgWo͂ɕ\
//******************************************
		if(TitleMessage) PrintTitle(TitleMessage);
//******************************************
// N̓t@C擾B
// o̓t@C쐬igq".out.txt"ɕύXj
//******************************************
		if(CheckArgs(argn, argv) < 1) Die(-1); //return -1;

		printf("Input File : %s\n", InputFilePath);
		printf("Output File: %s\n", OutputFilePath);

		int ret = OpenFiles();
		if(ret < 1) Die(ret); //return ret;

//******************************************
// vO^CgƓo̓t@COutputFileNameɏo
//******************************************
		if(TitleMessage) PrintTitle(out, TitleMessage);

		fprintf(out, "[Global files]\n");
		fprintf(out, "  Input File : %s\n", InputFilePath);
		fprintf(out, "  Output File: %s\n", OutputFilePath);
		fprintf(out, "\n");
		return 1;
	};
	int PrintTitle(const char*title[])
	{
		if(title == NULL) return -1;
		printf("==================================================\n");
		for(int i = 0 ; ; i++)
		{
			if(title[i] == NULL) break;
			printf("%s", title[i]);
		}
		printf("==================================================\n");
		printf("\n");
		return 1;
	};
	int PrintTitle(FILE *out, const char*title[])
	{
		if(title == NULL) return -1;
		fprintf(out, "==================================================\n");
		for(int i = 0 ; ; i++)
		{
			if(title[i] == NULL) break;
			fprintf(out, "%s", title[i]);
		}
		fprintf(out, "==================================================\n");
		fprintf(out, "\n");
		return 1;
	};
	int PrintEndingMessage()
	{
		mprintf(out, "\n");
		mprintf(out, "==================================================\n");
		mprintf(out, "  %s  finished\n", AppName);
		mprintf(out, "==================================================\n");
		return 1;
	};
	FILE *OpenOutputFile()
	{
		if((out = fopen(OutputFilePath, "w")) == NULL)
			printf("Can not write to %s\n", OutputFilePath);
		return out;
	};
	FILE *OpenInputFile()
	{
		if((in = fopen(InputFilePath, "r")) == NULL)
			printf("Can not read from %s\n", InputFilePath);
		return in;
	};
	int OpenFiles()
	{
		if(OpenInputFile() == NULL) return -1;
		if(OpenOutputFile() == NULL) return -2;
		return 1;
	};
	int CloseInputFile()
	{
		if(in == NULL) return 0;
		fclose(in);
		in = NULL;
		return 1;
	};
	int CloseOutputFile()
	{
		if(out == NULL) return 0;
		fclose(out);
		out = NULL;
		return 1;
	};
	int CloseFiles()
	{
		if(CloseInputFile() == -1) return 0;
		if(CloseOutputFile() == -1) return 0;
		return 1;
	};
	int CheckArgs(int argn, char *argv[])
	{
		if(argn <= 1)
		{
			printf("Error!!: Invalid argument\n\n");
			printf("     Usage: %s infile\n\n", AppName);
			return -1;
		}
		strcpy(InputFilePath, argv[1]);
		strcpy(OutputFilePath, InputFilePath);
		ReplaceExtention(OutputFilePath, ".out.txt");
		return 1;
	};
};

#endif // !defined(AFX_CONSOLEAPP_H__94D9030A_D9A3_46D8_848C_DA16DE7AD40D__INCLUDED_)
