// Utils.cpp: CUtils NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

//#include "windows.h"
#include "Utils.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CUtils::CUtils()
{

}

CUtils::~CUtils()
{

}

void CUtils::SwapDouble(double& r1, double& r2)
{
	double r =r1;
	r1 = r2;
	r2 = r;
}

void CUtils::SwapInt(int& min, int& max)
{
	int r = max;
	max = min;
	min = r;
}

//double wfs[100][100];
/*
int jacobi(CMyMatrix<double>& wfs, CMyMatrix<double>& w, CMyVector<double>& e, int Maxloop)
{
	int n = wfs.nLength();

	int	i, j, k, p, q ;
	int	count ;
	double amax ;
//the largest value of a[][]
	double	sinth, costh, tanth ;
	double	app, apq, aqq, akp, akq, wkp, wkq  ;
	double  mmax=0;

	for(i = 0 ; i < n ; i++) 
	{
		for(j = 0 ; j < n ; j++) 
		{
			w[i][j] = 0.0; //w[i*n+j] = 0.0 ;
		}
		w[i][i] = 1.0; //w[i*n+i] = 1.0 ;
	}

	for(i=0;i<n;i++)
		if(fabs(wfs[i][i]) > mmax) mmax = wfs[i][i];

	for(count = 0 ; count < Maxloop ; count++) 
	{
		amax = 0.0;
		for(i = 0 ; i < n ; i++)
		{
			for(j = 0 ; j < n ; j++)
			{
				if( (i != j) && (fabs(amax) < fabs(wfs[i][j])) ) 
				{
					p = i ;
					q = j ;
					amax = wfs[i][j] ;
				}
			}
		}

		if( fabs(amax) < mmax*1.0e-4 ) 
		{
			for(k = 0 ; k < n ; k++)
			    e[k] = wfs[k][k] ;
			return 0;
		}

		tanth = 2.0 * wfs[p][q] ;
		tanth /=  wfs[p][p]-wfs[q][q] + sqrt( CAlgorism::sqre((wfs[p][p]-wfs[q][q])) + 4*wfs[p][q]*wfs[p][q]) ;
		costh = 1.0 / sqrt(1.0 + tanth*tanth) ;
		sinth = costh * tanth ;

		app = wfs[p][p];  
		aqq = wfs[q][q];
		apq = wfs[p][q];
		wfs[p][p] =  app*CAlgorism::sqre(costh) + 2.0*apq*sinth*costh + aqq*CAlgorism::sqre(sinth) ;
		wfs[q][q] =  app*CAlgorism::sqre(sinth) - 2.0*apq*sinth*costh + aqq*CAlgorism::sqre(costh) ;
		wfs[p][q] =  wfs[q][p] = 0.0 ;

		for(k = 0 ; k < n ; k++) 
		{
			if(k != p && k != q) 
			{
				akp = wfs[k][p];
				akq = wfs[k][q];
				wfs[k][p] =  wfs[p][k] =  akp*costh + akq*sinth;
				wfs[k][q] =  wfs[q][k] = -akp*sinth + akq*costh;
			}
		}
//for eigen matrix
		for(k = 0 ; k < n ; k++) 
		{
			wkp = w[k][p]; //wkp = w[k*n+p];
			wkq = w[k][q]; //wkq = w[k*n+q];
			w[k][p] =  wkp*costh + wkq*sinth; //w[k*n+p] =  wkp*costh + wkq*sinth;
			w[k][q] = -wkp*sinth + wkq*costh; //w[k*n+q] = -wkp*sinth + wkq*costh;
		}
	}
	return -1 ;
}
*/
double CUtils::FreqToKeiser(double f)
{
	const double c = CConstants::c; // m/s
	double l = c / f; // m
	return 1.0 / (l*100.0); // cm-1
}

double CUtils::NMtoAU(double x)
{
	const double a0 = CConstants::a0 * 1.0e9; // nm Bohr radius
	return x / a0;
}

const char * CUtils::DelCRLF(char *str)
{
	char *cp = strchr(str, '\r');
	if(cp) *cp = 0;
	cp = strchr(str, '\n');
	if(cp) *cp = 0;
	return str;
}

int CUtils::DelSpace(char *str)
{
	int len = strlen(str);
	if(len <= 0) return -2;
	char *cp;
	for(cp= str + len - 1; cp >= str ; cp--)
	{
		if(strchr(" \t\r\n", *cp) == NULL)
		{
			*(cp+1) = 0;
			break;
		}
	}
	for(cp= str; *cp != 0 ; cp++)
	{
		if(strchr(" \t\r\n", *cp) == NULL)
			break;
	}
	if(cp == str) return -2;
	memmove(str, cp, strlen(cp)+1);
	return 0;
}

int CUtils::DelSpace(string& s)
{
	char *str = new char[s.length()+1];
	strcpy(str, s.c_str());
	int ret = DelSpace(str);
	s = str;
	return ret;
}

int CUtils::DelQuote(char *str)
{
	DelSpace(str);
	char *cp = str;
	char *cpe = cp + strlen(cp) - 1;
	if( (*cp == '\"' && *cpe == '\"') ||
		(*cp == '\'' && *cpe == '\'') )
	{
		cp++;
		*cpe = 0;
		memmove(str, cp, strlen(cp)+1);
	}
	else return -1;
	return 0;
}

int CUtils::DelQuote(string& s)
{
	char *str = new char[s.length()+1];
	strcpy(str, s.c_str());
	int ret = DelQuote(str);
	s = str;
	return ret;
}

char *CUtils::SkipSpace(char *str)
{
	while(*str != 0)
	{
		if(strchr(" \t\r\n", *str) == 0) return str;
		str++;
	}
	return str;
}

double CUtils::Reduce01(double x)
{
	double xx;
	if(0.0 <= x && x < 1.0) return x;
	xx = x - (int)x;
	while(xx < 0.0) xx += 1.0;
	while(xx >= 1.0-1.0e-10) xx -= 1.0;
	return xx;
}

const char* CUtils::SkipSpace(const char* cp)
{
	if(cp == NULL) return NULL;
	while(*cp != 0)
	{
		if(strchr(" \t\n\r", *cp) == NULL) break;
		cp++;
	}
	return cp;
}

const char* CUtils::FortranDoubleToCDouble(char *buff)
{
	for(char *cp = buff ; *cp != 0 ; cp++)
		if(*cp == 'D') *cp = 'E';
	return buff;
}

int CUtils::RemoveSpaces(char *str, const char* url)
{
	char *cp = str;
	const char* src = url;
	while(*src != 0)
	{
		if(strchr(" \t\r\n", *src) != NULL)
		{
			src++;
			continue;
		}
		if(_ismbblead(*src) && _ismbbtrail(*(src+1)) &&
			strncmp(src, "@", 2) == 0)
		{
			src += 2;
			continue;
		}

		*cp = *src;
		cp++;
		src++;
	}
	*cp = 0;
	return 1;
}

char *CUtils::CopytoDoubleQuotation(char *cp, char *str)
{
	while(*cp != 0)
	{
		if(*cp == '\"') break;
		*str = *cp;
		cp++;
		str++;
	}
	*str = 0;
	return cp;
}

char *CUtils::CopytoSpace(char *cp, char *str)
{
	while(*cp != 0)
	{
		if(*cp == ' ') break;
		*str = *cp;
		cp++;
		str++;
	}
	*str = 0;
	return cp;
}

int CUtils::ExtractFromCommandLineArg(char *line, int index, char *str)
{
	*str = 0;
	char *cp = line;
	while(*cp != 0)
	{
		switch(*cp)
		{
		case '\"':
			cp = CopytoDoubleQuotation(cp+1, str);
			index--;
			if(index == 0) return strlen(str);
			break;
		case ' ':
			cp = SkipSpace(cp+1);
			break;
		default:
			cp = CopytoSpace(cp, str);
			index--;
			if(index == 0) return strlen(str);
			break;
		}
		cp++;
	}
	return strlen(str);
}

void CUtils::SplitColonedString(char* str, char **Header, char **Find, char **Folder)
{
	char buff[256];
	strcpy(buff, str);
	char *src = buff, *dest = str;
	int idx = 0;
	char *bufp[3];

	bufp[0] = str;
	bufp[1] = NULL;
	bufp[2] = NULL;
	for( ; *src != 0 ; )
	{
		if(idx < 2 && *src == ':')
		{
			src++;
			if(*src == ':')
			{
				*dest = *src;
				dest++;
				src++;
				continue;
			}
			else
			{
				*dest = 0;
				dest++;
				idx++;
				bufp[idx] = dest;
				*dest = *src;
				src++;
				dest++;
				continue;
			}
		}
		*dest = *src;
		dest++;
		src++;
	}
	*dest = 0;
	*Header = bufp[0];
	if(bufp[1] != NULL) *Find = bufp[1];
	else *Find = *Header + strlen(*Header);
	if(**Find == ' ') (*Find)++;
	if(bufp[2] != NULL) *Folder = bufp[2];
	else *Folder = *Header + strlen(*Header);
	if(**Folder == ' ') (*Folder)++;
}

void CUtils::MergeStringsColoned(char* str, char* Header, char* Find,  char* Folder)
{
	char *src[3];
	src[0] = Header;;
	src[1] = Find;
	src[2] = Folder;
	char *dest = str;
	int idx = 0;

	while(1)
	{
		if(*(src[idx]) == 0)
		{
			if(idx >= 2)
			{
				*dest = 0;
				return;
			}
			idx++;
			strcpy(dest, ": ");
			dest += 2;
			continue;
		}
		else if(idx < 2 && *(src[idx]) == ':')
		{
			strcpy(dest, "::");
			dest += 2;
			(src[idx])++;
			continue;
		}
		else
		{
			*dest = *(src[idx]);
			dest++;
			(src[idx])++;
			continue;
		}
	}
}

int CUtils::CountCharacter(const char* str, char c)
{
	int count = 0;
	while(*str != 0)
	{
		if(*str == c) count++;
		str++;
	}
	return count;
}

void CUtils::GetArgs(char *str, int &n, char **argv)
{
	static char Arguments[_MAX_PATH];
	static char ArgumentsArray[_MAX_PATH];
	char *cp;

	strcpy(ArgumentsArray, str);
	cp = ArgumentsArray;
	n = 0;
	while(1)
	{
		if(*cp == ' ' || *cp == '\r' || *cp == '\n')
		{
			cp++;
			continue;
		}
		if(*cp == 0) return;
		break;
	}
	argv[n] = cp;
	if(*cp == 0) return;
	while(1)
	{
		if(*cp == 0)
		{
			n++;
			return;
		}
		if(*cp == ' ' || *cp == '\r' || *cp == '\n')
		{
			*cp = 0;
			cp++;
			while(*cp == ' ' || *cp == '\r' || *cp == '\n') cp++;
			n++;
			argv[n] = cp;
			continue;
		}
		cp++;
	}
}

//"܂łargv[n]ɑAcp"̎|Cg
static char *GetStrToNextQuote(char *sourcestr, char *targetstr)
{
	char *cps = sourcestr;
	char *cpt = targetstr;
	*cpt++ = *cps++;
	while(*cps != 0)
	{
		if(*cps == '\"')
		{
			*cpt++ = *cps++;
			*cpt = 0;
			return cps;
		}
		else if(*cps == '\\' && *(cps+1) == '\"')
		{
			*cpt++ = *cps++;
			*cpt++ = *cps++;
		}
		else 
		{
			*cpt++ = *cps++;
		}
	}
	*cpt = 0;
//	*(cpt+1) = 0;
	return cps;
}

//̋󔒂̑O܂łargv[n]ɑAcp͋󔒂|Cg
static char *GetStrToNextSpace(char *sourcestr, char *targetstr)
{
	char *cps = sourcestr;
	char *cpt = targetstr;
	*cpt++ = *cps++;
	while(*cps != 0)
	{
		if(strchr(" \t\r\n", *cps))
		{
			*cpt = 0;
//char s[100];
//sprintf(s, "[%s][%s]", sourcestr, cps);
//MessageBox(NULL, s, targetstr, MB_OK);
			return cps;
		}
		*cpt++ = *cps++;
	}
	*cpt = 0;
//	*(cpt+1) = 0;
//char s[100];
//sprintf(s, "[%s][%s]", sourcestr, cps);
//MessageBox(NULL, s, targetstr, MB_OK);
	return cps;
}

void CUtils::GetArgs(char *str, int &n, char **argv, bool RecognizeQuote)
{
	if(!RecognizeQuote) GetArgs(str, n, argv);

	static char Arguments[_MAX_PATH];
	static char ArgumentsArray[_MAX_PATH];
	char tempstr[LEN_BUF];
	char *cp;

	strcpy(ArgumentsArray, str);
	cp = ArgumentsArray; //Ƃstrւ̃|C^
	n = 0; // Argment̐
	while(*cp != 0)
	{
		if(*cp == '\"') 
		{
//"܂łargv[n]ɑAcp"̎|Cg
			char *cp2 = GetStrToNextQuote(cp, tempstr);
			bool IsEnd = false;
			if(*cp2 == 0) IsEnd = true;
			strcpy(cp, tempstr);
			argv[n] = cp;
			n++;
			if(IsEnd) return;
			cp = cp2+1;
			continue;
		}

// Argment𔭌
		cp = SkipSpace(cp);
//̋󔒂̑O܂łargv[n]ɑAcp͋󔒂|Cg
		char *cp2 = GetStrToNextSpace(cp, tempstr);
		bool IsEnd = false;
		if(*cp2 == 0) IsEnd = true;
		strcpy(cp, tempstr);
		argv[n] = cp;
		n++;
//char s[100];
//sprintf(s, "%d: [%s] [%s]", n, argv[n-1], cp2);
//MessageBox(NULL, str, s, MB_OK);
		if(IsEnd) return;
		cp = cp2+1;
	}
	return;
}

int CUtils::nArgs(char *str)
{
	char *cp;
	int narg = 0;

	cp = str;
	while(1)
	{
		if(*cp == ' ' || *cp == '\r' || *cp == '\n')
		{
			cp++;
			continue;
		}
		if(*cp == NULL) return narg;
		break;
	}
	while(1)
	{
		if(*cp == NULL)
		{
			narg++;
			return narg;
		}
		if(*cp == ' ' || *cp == '\r' || *cp == '\n')
		{
			*cp = NULL;
			cp++;
			while(*cp == ' ' || *cp == '\r' || *cp == '\n') cp++;
			narg++;
			continue;
		}
		cp++;
	}
}

bool CUtils::MyCopyFile(const char *src, const char *dest)
{
	FILE *in, *out;
	char c;

	if(stricmp(src, dest) == NULL) return true;
	if((in = fopen(src, "rb")) == NULL) return false;
	if((out = fopen(dest, "wb")) == NULL) return false;
	while(1)
	{
		c = (char)fgetc(in);
		if(feof(in)) break;
		fputc(c, out);
	}
	fclose(in);
	fclose(out);
	return true;
}

int CUtils::ReadNextData(FILE *in, char *buff, int len, char *SkipHeader)
{
	int headerlen = strlen(SkipHeader);
	while(1)
	{
		fgets(buff, len, in);
		if(feof(in)) return 0;
		CUtils::DelSpace(buff);
		if(strncmp(buff, SkipHeader, headerlen) == 0) continue;
		break;
	}
	return 1;
}

int CUtils::ReadSkipTo(FILE *in, char *TargetHeader, bool DoRewind)
{
	char buff[LEN_BUF];

	if(DoRewind) rewind(in);
	int headerlen = strlen(TargetHeader);
	while(1)
	{
		fgets(buff, LEN_BUF, in);
		if(feof(in)) return 0;
		CUtils::DelSpace(buff);
		if(strncmp(buff, TargetHeader, headerlen) == 0) return 1;
	}
	return 0;
}

bool CUtils::IsMatchFile(const char * filename, const char * mask)
{
	char *cp1 = strrchr(filename, '.');
	char *cp2 = strrchr(mask, '.');
	if(cp1 == NULL) cp1 = "";
	if(cp2 == NULL) cp2 = "";
	if(stricmp(cp1, cp2) == 0) return true;
	return false;
}

bool CUtils::IsMatchFileWithMasks(const char * filename, const char * FileMasks)
{
	char filemask[256];
	strcpy(filemask, FileMasks);
	char *cp = filemask;
	char *cp1;
	while(1)
	{
		cp1 = strchr(cp, ';');
		if(cp1) *cp1 = 0;
		if(*cp != 0 && IsMatchFile(filename, cp)) return true;
		if(cp1 == NULL) break;
		cp = cp1+1;
	}
	return false;
}

int CUtils::MakePath(char *path, const char *folder, const char *filename)
{
//	_makepath(path, "", folder, filename, "");
	const char * cp = folder + strlen(folder) - 1;
	
	if(*cp == '\\' && !_ismbblead(*(cp-1)))
		sprintf(path, "%s%s", folder, filename);
	else if(*folder == 0)
		strcpy(path, filename);
	else
		sprintf(path, "%s\\%s", folder, filename);
	return 1;
}
