// Utils.h: CUtils NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_UTILS_H__872AA090_2FFA_4EE8_9B99_A4DB2FEAA5C8__INCLUDED_)
#define AFX_UTILS_H__872AA090_2FFA_4EE8_9B99_A4DB2FEAA5C8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <stdio.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdarg.h>
#include <io.h>
#include <fcntl.h>
#include <stddef.h>
#include <stdlib.h>
#include <string.h>
#include <mbstring.h>
#include <math.h>
#include <direct.h>

#include <cstdlib>
#include <complex>
#include <string>

//#include "ConsoleApp.h"
//#include "Array.h"
#include "Constants.h"
#include "Common.h"

using namespace std;

//class CUtils : public CDeps
class CUtils
{
public:
	static void SwapDouble(double& r1, double& r2);
	static void SwapInt(int& min, int& max);
	static const char* FortranDoubleToCDouble(char *buff);

	static double FreqToKeiser(double f);
	static double NMtoAU(double x);

	static double Reduce01(double x);
	static char *SkipSpace(char *str);
	static const char* SkipSpace(const char* cp);
	static int DelQuote(char *str);
	static int DeleteQuote(char *str)
	{
		return DelQuote(str);	
	};
	static int DelQuote(string& s);
	static int DeleteQuote(string& s)
	{
		return DelQuote(s);
	};
	static int DelSpace(char *str);
	static int DelSpace(string& s);
	static int RemoveSpaces(char *str, const char* url);
	static const char * DelCRLF(char *str);
	static char *CopytoSpace(char *cp, char *str);
	static char *CopytoDoubleQuotation(char *cp, char *str);

	static void MergeStringsColoned(char* str, char* Header, char* Find,  char* Folder);
	static void SplitColonedString(char* str, char **Header, char **Find, char **Folder);
	static int  CountCharacter(const char* str, char c);

	static int  ExtractFromCommandLineArg(char *line, int index, char *str);

	static void GetArgs(char *str, int &n, char **argv, bool RecognizeQuote);
	static void GetArgs(char *str, int &n, char **argv);
	static int  nArgs(char *str);

	static int MakePath(string& path, const char * folder, const char * filename)
	{
		char str[4096];
		int ret = MakePath(str, folder, filename);
		path = str;
		return ret;
	};
	static int MakePath(char * path, const char * folder, const char * filename);
	static bool IsMatchFile(const char * filename, const char * mask);
	static bool IsMatchFileWithMasks(const char * filename, const char * FileMasks);

	static bool MyCopyFile(const char *src, const char *dest);
	static int ReadNextData(FILE *in, char *buff, int len, char *SkipHeader);
	static int ReadSkipTo(FILE *in, char *TargetHeader, bool DoRewind = true);

	static char *MakeUpper(char *str) {
		for(char *cp = str ; *cp != 0 ; cp++) *cp = (char)toupper(*cp);
		return str;
	};
	static char *MakeLower(char *str) {
		for(char *cp = str ; *cp != 0 ; cp++) *cp = (char)tolower(*cp);
		return str;
	};
	static char *ucfirst(char *str) {
		*str = (char)toupper(*str);
		return str;
	};
	static char *lcfirst(char *str) {
		*str = (char)tolower(*str);
		return str;
	};

static int printf(const char *format ...)
{
	va_list ap;
	va_start(ap, format);
	vprintf(format, ap);
	va_end(ap);
	return 0;
};

static char *ReplaceExtension(char *fname, const char *ext) {
	char *cp = strrchr(fname, '.');
	char *cp1 = strrchr(fname, '\\');
	if(cp1 < cp) *cp = 0;
	sprintf(fname, "%s.%s", fname, ext);
	return fname;
};

static int IsExist(const char* fname) {
	FILE *in = fopen(fname, "r");
	if(in == NULL) return 0;
	fclose(in);
	return 1;
};
static char* DelAllSpace(char* s) {
	int len = strlen(s);
	char *s1 = new char[len+1];
	if(s1 == NULL) return s;
	char *cp1 = s;
	char *cp2 = s1;
	while(*cp1 != 0) {
		if(strchr(" \t\r\n", *cp1) != NULL) {
			*cp1++;
			continue;
		}
		*cp2++ = *cp1++;
	}
	*cp2 = 0;
	strcpy(s, s1);
//printf("s: %s\n", s);
	delete []s1;
	return s;
};

	CUtils();
	virtual ~CUtils();
};

#endif // !defined(AFX_UTILS_H__872AA090_2FFA_4EE8_9B99_A4DB2FEAA5C8__INCLUDED_)
