#include "cinifile.h"

CIniFile::CIniFile(HINSTANCE hInstance)
{
	*_IniFile = 0;
	*_MyDir = 0;
	*_WinDir = 0;
	CreateIniFileName(hInstance);
}

CIniFile::CIniFile(char *filename)
{
	*_IniFile = 0;
	*_MyDir = 0;
	*_WinDir = 0;

	if(*filename != 0)
	{
		strcpy(_MyDir, filename);
		char *cp = _MyDir + strlen(_MyDir) - 1;
		for( ; *cp != '\\' && cp > _MyDir ; cp--) ;
		if(cp > _MyDir) *cp = 0;
		else *_MyDir = 0;
		strcpy(_IniFile, filename);
		cp = strrchr(_IniFile, '.');
		if(cp != NULL) strcpy(cp, ".Ini");
		else strcat(_IniFile, ".Ini");
	}
	GetWindowsDirectory(_WinDir, 256);
	GetTempPath(256, _TempDir);
}

CIniFile::~CIniFile()
{
}

BOOL CIniFile::SaveCurrentDir(char *lpszSection, char *lpszKey, char *fname)
{
	char buf[256];
	strcpy(buf, fname);
	char *cp = buf + strlen(buf);
	for( ; *cp != '\\' && cp > buf ; cp--) ;
	if(*cp == '\\')
	{
		if(*(cp-1) == ':') *(cp+1) = 0;
		else *cp = 0;
	}
	return WriteString(lpszSection, lpszKey, buf);
}

BOOL CIniFile::IsValid()
{
	if(*_IniFile == 0) return FALSE;
	return TRUE;
}

BOOL CIniFile::GetBool(char *lpszSection, char *lpszKey, BOOL dwDefault)
{
	int def;
	if(dwDefault) def = 1;
	else def = 0;
	if(GetPrivateProfileInt(lpszSection, lpszKey, def, _IniFile) == 0)
				return FALSE;
	else 		return TRUE;
}

BOOL CIniFile::CreateIniFileName(HINSTANCE hInstance)
{
	GetModuleFileName(hInstance, _IniFile, 256);
	char *cp = _IniFile + strlen(_IniFile) - 1;
	for( ; *cp != '\\' && *cp != '.' ; cp--) ;
	if(*cp == '.') *cp = 0;
	strcpy(_MyDir, _IniFile);
	strcat(_IniFile, ".INI");

	cp = _MyDir + strlen(_MyDir) - 1;
	for( ; *cp != '\\' ; cp--) ;
	*cp = 0;

	GetWindowsDirectory(_WinDir, 256);
	GetTempPath(256, _TempDir);

	return TRUE;
}




