#if !defined(AFX_SETUPCURVEFITVIEW_H__F46A9733_CD03_11D1_B2C2_0000F81EA28D__INCLUDED_)
#define AFX_SETUPCURVEFITVIEW_H__F46A9733_CD03_11D1_B2C2_0000F81EA28D__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// SetupCurveFitView.h : wb_[ t@C
//
#include "CurveFitDoc.h"

/////////////////////////////////////////////////////////////////////////////
// CSetupCurveFitView tH[ r[

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

class CSetupCurveFitView : public CFormView
{
protected:
	CSetupCurveFitView();           // IɎgpveNg RXgN^B
	DECLARE_DYNCREATE(CSetupCurveFitView)

// tH[ f[^
public:
	int ExecutePeakFitLSQ(LPCSTR LSQProgram);
	int ExecuteRmnFitLSQ();
	void UpdatePeakSearch();
	int ReadPFCFile(LPCSTR pfcfile);
	int ReadXRDPFCFile(LPCSTR pfcfile);
	int ReadRamanPFCFile(LPCSTR pfcfile);
	int SaveCurrentSetting();
	int UpdatePeakList(int idx);
	int ClearDialog(bool clearlist = false);
	CString& SetInputpath();
	CCurveFitDoc *GetDocument() { return (CCurveFitDoc*)CView::GetDocument(); };
	CGraphFrameArray *GetGraphFrameArray() { return GetDocument()->GetGraphFrameArray(); };
	CGraphFrame      *GetGraphFrame(int i) { return GetDocument()->GetGraphFrame(i); };
	
	//{{AFX_DATA(CSetupCurveFitView)
	enum { IDD = IDD_CURVEFITCONDITIONDIALOG };
	CButton	m_YAxisType;
	CSpinButtonCtrl	m_AnisoSpin;
	CSpinButtonCtrl	m_GaussFractionSpin;
	CSpinButtonCtrl	m_FWHMLorentzSpin;
	CSpinButtonCtrl	m_FWHMGLRatioSpin;
	CSpinButtonCtrl	m_PositionSpin;
	CSpinButtonCtrl	m_FWHMGaussSpin;
	CSpinButtonCtrl	m_CTotalSpin;
	CSpinButtonCtrl	m_CLorentzSpin;
	CSpinButtonCtrl	m_CGaussSpin;
	CSpinButtonCtrl	m_b4Spin;
	CSpinButtonCtrl	m_b3Spin;
	CSpinButtonCtrl	m_b2Spin;
	CSpinButtonCtrl	m_b1Spin;
	CSpinButtonCtrl	m_b0Spin;
	CComboBox	m_PeakList;
	CString	m_OutputPath;
	CString	m_InputPath;
	CString	m_PFCPath;
	double	m_OptRegionX1;
	double	m_OutputRegionX0;
	double	m_OutputRegionX1;
	double	m_OptRegionX0;
	BOOL	m_AutoRedraw;
	BOOL	m_Optimizeb0;
	double	m_b0;
	double	m_b1;
	BOOL	m_Optimizeb2;
	BOOL	m_Optimizeb1;
	double	m_b2;
	double	m_IRatio;
	double	m_LKa1;
	double	m_LKa2;
	BOOL	m_OptimizePosition;
	double	m_Position;
	double	m_QRange;
	BOOL	m_OptimizeCGauss;
	double	m_CGauss;
	BOOL	m_OptimizeCLorentz;
	double	m_CLorentz;
	BOOL	m_OptimizeFWHMGauss;
	double	m_FWHMGauss;
	BOOL	m_OptimizeFWHMLorentz;
	double	m_FWHMLorentz;
	int		m_iPeak;
	BOOL	m_OptimizeCTotal;
	double	m_CTotal;
	BOOL	m_OptimizeFWHMGLRatio;
	double	m_FWHMGLRatio;
	BOOL	m_OptimizeGaussFraction;
	double	m_GaussFraction;
	BOOL	m_Optimizeb3;
	double	m_b3;
	BOOL	m_Optimizeb4;
	double	m_b4;
	double	m_DeltaMag;
	BOOL	m_OptimizeAniso;
	double	m_Aniso;
	//}}AFX_DATA

// Agr[g
public:

// Iy[V
public:
	int ReadFile(LPCSTR filename);
// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CSetupCurveFitView)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	virtual ~CSetupCurveFitView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CSetupCurveFitView)
	afx_msg void OnRedrawbutton();
	afx_msg void OnSetuplsqbutton();
	afx_msg void OnOutputpathbutton();
	afx_msg void OnInputpathbutton();
	virtual BOOL OnInitDialog();
	afx_msg void OnClose();
	afx_msg void OnPfcpathbutton();
	afx_msg void OnDestroy();
	afx_msg void OnGetViewRangeAsOutputRegionButton();
	afx_msg void OnGetViewRangeAsOptRegionButton();
	afx_msg void OnPeaksearchbutton();
	afx_msg void OnClearpeaksbutton();
	afx_msg void OnAddpeakbutton();
	afx_msg void OnDeletepeakbutton();
	afx_msg void OnDeltaposB0spin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSelchangePeaklistcombo();
	afx_msg void OnDeltaposB1spin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposB2spin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposB3spin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposB4spin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposCgaussspin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposClorentzspin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposCtotalspin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposFwhmgaussspin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposFwhmglratiospin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposFwhmlorentzspin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposGaussfractionspin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposPositionspin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnExeccurvefitbutton();
	afx_msg void OnEditpfcfilebutton();
	afx_msg void OnEditoutputfilebutton();
	afx_msg void OnEditinputfilebutton();
	afx_msg void OnSetoptimizeviewrangebutton();
	afx_msg void OnSetoutputviewrangebutton();
	afx_msg void OnSavepfcfilebutton();
	afx_msg void OnChangeB0edit();
	afx_msg void OnChangeB1edit();
	afx_msg void OnChangeB2edit();
	afx_msg void OnChangeB3edit();
	afx_msg void OnChangeB4edit();
	afx_msg void OnChangeCgaussedit();
	afx_msg void OnChangeClorentzedit();
	afx_msg void OnChangeCtotaledit();
	afx_msg void OnChangeFwhmgaussedit();
	afx_msg void OnChangeFwhmglratioedit();
	afx_msg void OnChangeFwhmlorentzedit();
	afx_msg void OnChangeGaussfractionedit();
	afx_msg void OnChangeLka1edit();
	afx_msg void OnChangeLka2edit();
	afx_msg void OnChangePositionedit();
	afx_msg void OnChangeQrangeedit();
	afx_msg void OnDefaultxrdparambutton();
	afx_msg void OnDeltaposAnisotropyspin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnChangeAnisotropyedit();
	afx_msg void OnCalcbgbutton();
	afx_msg void OnYAxisTypeButton();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_SETUPCURVEFITVIEW_H__F46A9733_CD03_11D1_B2C2_0000F81EA28D__INCLUDED_)
