#============================================================
# TkWiki
#============================================================
package CGI::TkWiki;
use Common;
@ISA = qw(Common);

#֥롼
#@EXPORT   = qw(erfc tan);
@EXPORT_OK = qw();

use strict;
use Cwd;

use JFile;
use Template;
use MyMail;
use JSParams;

#==========================================
# ѿ
#==========================================
sub WikiDir       { return shift->{WikiDir}; }
sub SetWikiDir    { my ($this,$d)=@_; return $this->{WikiDir} = $d; }
sub SetModuleName { my ($this,$n)=@_; return $this->{ModuleName} = $n; }
sub SetTemplatePaths { 
	my ($this, $HTML, $Wiki, $Text) = @_;
#Utils::InitHTML();
#print "T[$HTML][$Wiki]<br>\n";
	$this->{HTMLTemplatePath} = $HTML;
	$this->{WikiTemplatePath} = $Wiki;
	$this->{TextTemplatePath} = $Text;
#print "SetTemplatePaths T[$this->{ModuleName}][$this->{HTMLTemplatePath}][$this->{WikiTemplatePath}]<br>\n";
}
sub GetWikiPath {
	my ($this, $App, $pParams, $FileName) = @_;

Jcode::convert(\$FileName, $pParams->{FileSystemCharCode});
	my $path;
	$path =~ s/\\/\//g;
	if(defined $pParams->{CurDir}) {
Jcode::convert(\$pParams->{CurDir}, $pParams->{FileSystemCharCode});
		if($pParams->{CurDir} eq '/.') {
			$path = Utils::MakePath($this->{WikiDir}, [$FileName], '/', 0);
		}
		else {
			$path = Utils::MakePath($this->{WikiDir}, [$pParams->{CurDir}, $FileName], '/', 0);
		}
	}
	else {
Jcode::convert(\$pParams->{WikiDir}, $pParams->{FileSystemCharCode});
		$path = Utils::MakePath($this->{WikiDir}, $FileName, '/', 0);
	}
#	$path =~ s/\/\.\//\//g;
#$App->print("F: $path [$FileName]\n");
#Jcode::convert(\$path, "utf-8", "sjis"); #$pParams->{FileSystemCharSet});
#$App->print("F: $path\n");
	return $path;
}

#============================================================
#󥹥ȥ饯ǥȥ饯
#============================================================
sub new
{
	my ($module) = @_;
	my $this = {};
	bless $this;
#	$this->SUPER::new(@_);
	return $this;
}

sub DESTROY
{
	my $this = shift;
	$this->SUPER::DESTROY(@_);
}

#============================================================
#Сؿ
#============================================================
sub DecodeFSWikiName
{
	my ($this, $filename) = @_;

	my $filebody = $filename;
	$filebody =~ s/\.wiki$//i;
	my $s2 = $filebody;
	$s2 = Utils::URLDecode($filebody);
#print "s2: $s2\n";
	my $guess = Encode::Guess::guess_encoding($s2);
	my $s3;
	unless(ref $guess){
# Ƚ̼
#print("Cannot guess: $guess\n");
#		$s3 = from_to($s2, "euc-jp", "shift-jis");
		$s3 = $s2;
	}
	else {
# Ƚ
		$s3 = $guess->decode($s2);
		$s3 = Encode::encode("shift-jis", $s3);
	}
#print "$s2: $s3\n";
	return $s3;
}

sub DecodePukiWikiName
{
	my ($this, $filename) = @_;

	my $filebody = $filename;
	$filebody =~ s/\.txt$//i;
	my $s2 = $filebody;
	if($filebody =~ /^[0-9a-fA-F]+$/) {
		$s2 = Utils::HexDecode($filebody);
	}
#print "s2: $s2\n";
	my $guess = Encode::Guess::guess_encoding($s2);
	my $s3;
	unless(ref $guess){
# Ƚ̼
#print("Cannot guess: $guess\n");
#		$s3 = from_to($s2, "euc-jp", "shift-jis");
		$s3 = $s2;
	}
	else {
# Ƚ
		$s3 = $guess->decode($s2);
		$s3 = Encode::encode("shift-jis", $s3);
	}
#print "$s2: $s3\n";
	return $s3;
}

sub ConvertURLLinksAll
{
	my ($this, $App, $pParams, $text) = @_;

	$text =~ s/(https?:\/\/[\w:\/\@\.\-#&?\%\~]*)/<a href="$1">$1<\/a>/sig;
	$text =~ s/(ftps?:\/\/[\w:\/\@\.\-]*)/<a href="$1">$1<\/a>/sig;
	$text =~ s/([\w%\._\-]+\@[\w\._\-]+)/<a href="mailto:$1">$1<\/a>/sig;
	return $text;
}

sub ConvertURLLinks
{
	my ($this, $App, $pParams, $text) = @_;

	my $conv = '';
	while(1) {
		my ($head, $mid, $tail) = ($text =~ /^(.*?)\<(.*?)\>(.*)$/s);
#$App->print("head: $head / $mid / $tail\n");
		if(!defined $tail) {
			$text = $this->ConvertURLLinksAll($App, $pParams, $text);
#			$text =~ s/(https?:\/\/[\w:\/\@\.\-#&?]*)/<a href="$1">$1<\/a>/sig;
#			$text =~ s/(ftps?:\/\/[\w:\/\@\.\-]*)/<a href="$1">$1<\/a>/sig;
			$conv .= $text;
			last;
		}
		$head = $this->ConvertURLLinksAll($App, $pParams, $head);
#		$head =~ s/(https?:\/\/[\w:\/\@\.\-#&?]*)/<a href="$1">$1<\/a>/sig;
#		$head =~ s/(ftps?:\/\/[\w:\/\@\.\-]*)/<a href="$1">$1<\/a>/sig;
		$conv .= "$head<$mid>";
		$text = $tail;
	}
#	$text =~ s/(https?[\w:\/\@\.\-#&?]*)/<a href="$1">$1<\/a>/sig;
#	$text =~ s/(ftps?[\w:\/\@\.\-]*)/<a href="$1">$1<\/a>/sig;
	return $conv;
}

sub ConvertWikiPage
{
	my ($this, $App, $pParams, $text, $charcode) = @_;

	$text .= "\n";
my $OriginalCode = Jcode::getcode($text);
#print "Code: $OriginalCode<br>\n";
Jcode::convert(\$text, "euc-jp", $OriginalCode);

	$text =~ s/\-\>\{/&vbra;/sg;
	$text =~ s/\{\{/&dbra;/sg;
	$text =~ s/\}\}/&dket;/sg;
	$text = Template->new()->ReplaceByHash($text, $pParams, '{', '}', 0, $pParams->{WebCharSet}, 1);
	$text =~ s/&dbra;/{{/sg;
	$text =~ s/&dket;/}}/sg;
	$text =~ s/&vbra;/->{/sg;

#no strict;
#	$text =~ s/\{\{(.*?::.*?)\((.*?)\)\}\}/eval("$1(" . '$this,$App,$pParams,' . "$2);");/emg;
#	$text =~ s/\{\{(.*?\-\>.*?)\((.*?)\)\}\}/eval("$1(" . '$App,$pParams,' . "$2);");/emg;
#	$text =~ s/\{\{(.*?::.*?)\}\}/eval("$1(" . '$this,$App,$pParams);');/emg;
#	$text =~ s/\{\{(.*?\-\>.*?)\}\}/eval("$1(" . '$App,$pParams);');/emg;
#use strict;

#	$text = Template->new()->ReplaceByHash($text, $pParams, '{', '}', 0, $pParams->{WebCharSet}, 1);

	$text =~ s/\\&/&amp;/mg;
	$text =~ s/\\\</&lt;/mg;
	$text =~ s/\\\>/&gt;/mg;
	$text =~ s/\\\^/&sup;/mg;
	$text =~ s/\\\_/&sub;/mg;
	$text =~ s/\\\[/&kakubra;/mg;
	$text =~ s/\\\]/&kakuket;/mg;

	$text =~ s/\\\{/{/mg;
	$text =~ s/\\\}/}/mg;

	$text =~ s/\r\n/<br>/mg;
	$text =~ s/\n\r/<br>/mg;
	$text =~ s/\n/<br>/mg;
	$text =~ s/\r/<br>/mg;
	$text =~ s/\<br\>/<br>\n/mg;

	$text =~ s/'''(.*?)'''/\<b\>$1\<\/b\>/sig;
	$text =~ s/''(.*?)''/\<i\>$1\<\/i\>/sig;
	$text =~ s/==(.*?)==/\<strike\>$1\<\/strike\>/sig;
	$text =~ s/__(.*?)__/\<u\>$1\<\/u\>/sig;

	$text =~ s/\^\^([^\n]+?)\^\^/<sup>$1<\/sup>/mg;
	$text =~ s/__([^\n]+?)__/<sub>$1<\/sub>/mg;

	$text =~ s/^!!!(.*?)\<br\>/<h2>$1<\/h2>/mig;
	$text =~ s/^!!(.*?)\<br\>/<h3>$1<\/h3>/mig;
	$text =~ s/^!(.*?)\<br\>/<h4>$1<\/h4>/mig;

	$text =~ s/^""(.*?)\<br\>/<blockquote>$1<\/blockquote>/mig;

	$text =~ s/^----\s*?\<br\>/<hr>/mig;
	$text =~ s/^\/\/.*?\<br\>//mig;

	$text =~ s/^\s(.*\S.*?)\<br\>/<pre>\n$1\n<\/pre>/mig;
	$text =~ s/\n<\/pre\>\n\<pre\>//mig;

	$text =~ s/^\*\*\*(.*?)\<br\>/<ul>\n<ul>\n<ul>\n<li>$1<\/li>\n<\/ul>\n<\/ul>\n<\/ul>/mig;
	$text =~ s/^\*\*(.*?)\<br\>/<ul>\n<ul>\n<li>$1<\/li>\n<\/ul>\n<\/ul>/mig;
	$text =~ s/^\*(.*?)\<br\>/<ul>\n<li>$1<\/li>\n<\/ul>/mig;
	$text =~ s/^\<\/ul\>\n\<ul\>\n//mig;
	$text =~ s/^\<\/ul\>\n\<ul\>\n//mig;
	$text =~ s/^\<\/ul\>\n\<ul\>\n//mig;

	$text =~ s/^\+\+\+(.*?)\<br\>/<ol>\n<ol>\n<ol>\n<li>$1<\/li>\n<\/ol>\n<\/ol>\n<\/ol>/mig;
	$text =~ s/^\+\+(.*?)\<br\>/<ol>\n<ol>\n<li>$1<\/li>\n<\/ol>\n<\/ol>/mig;
	$text =~ s/^\+(.*?)\<br\>/<ol>\n<li>$1<\/li>\n<\/ol>/mig;
	$text =~ s/^\<\/ol\>\n\<ol\>\n//mig;
	$text =~ s/^\<\/ol\>\n\<ol\>\n//mig;
	$text =~ s/^\<\/ol\>\n\<ol\>\n//mig;

	$text =~ s/\<red\>(.*?)\<\/red\>/<font color="#FF0000">$1<\/font>/sig;
	$text =~ s/\<green\>(.*?)\<\/green\>/<font color="#00FF00">$1<\/font>/sig;
	$text =~ s/\<blue\>(.*?)\<\/blue\>/<font color="#0000FF">$1<\/font>/sig;
	$text =~ s/\<cyan\>(.*?)\<\/cyan\>/<font color="#00FFFF">$1<\/font>/sig;
	$text =~ s/\<magenta\>(.*?)\<\/magenta\>/<font color="#FF00FF">$1<\/font>/sig;
	$text =~ s/\<yellow\>(.*?)\<\/yellow\>/<font color="#FFFF00">$1<\/font>/sig;

	my @a = split(/\n/, $text);
	my $TableWriting = 0;
	$text = '';
	for(my $i = 0 ; $i < @a ; $i++) {
		my $line = $a[$i];
		if($line =~ /^,/) {
			if(!$TableWriting) {
				$text .= "<table border=\"1\">\n";
				$TableWriting = 1;
			}
			$line =~ s/^,//;
			my @b = split(/,/, $line);
			$text .= "  <tr>\n";
			for(my $j = 0 ; $j < @b ; $j++) {
				$text .= "    <td>$b[$j]</td>\n";
			}
			$text .= "  </tr>\n";
		}
		else {
			if($TableWriting) {
				$text .= "</table>\n";
				$TableWriting = 0;
			}
			$text .= $line;
		}
		$text .= "\n";
	}

	$text =~ s/\[(.*?)\|(.*?)\]/<a href="$2">$1<\/a>/mig;
	$text = $this->ConvertURLLinks($App, $pParams, $text);

	$text =~ s/^(\<\/ol\>\n)\<br\>\n/$1/mig;
	$text =~ s/^(\<\/ul\>\n)\<br\>\n/$1/mig;
	$text =~ s/^(\<h\d\>(.*?)\<\/h\d\>\n)\<br\>\n/$1/mig;
	$text =~ s/^(\<\/table\>\n)\<br\>\n/$1/mig;
	$text =~ s/^(\<\/pre\>\n)\<br\>\n/$1/mig;
	$text =~ s/^(\<hr\>\n)\<br\>\n/$1/mig;

#	$text =~ s//&lt;/</mg;
#	$text =~ s/&gt;/>/mg;
	$text =~ s/&sup;/^/mg;
	$text =~ s/&sub;/_/mg;
	$text =~ s/&kakubra;/[/mg;
	$text =~ s/&kakuket;/]/mg;

	$text =~ s/([^\\])\\([^\\])/$1$2/mg;
#	$text =~ s/([^\\])\\([^\\])/$1$2/mg;

no strict;
	$text =~ s/\{\{(.*?::.*?)\((.*?)\)\}\}/eval("$1(" . '$this,$App,$pParams,' . "$2);");/emg;
#	$text =~ s/\{\{(.*?\-\>.*?)\((.*?)\)\}\}/eval("$1(" . '$App,$pParams,' . "$2)");/emg;
#	$text =~ s/\{\{(.*?\-\>.*?)\((.*?)\)\}\}/eval("&ExecuteSubroutine($App,$pParams,$1,$2)");/emg;
	$text =~ s/\{\{(.*?\-\>.*?)\((.*?)\)\}\}/&ExecuteSubroutine($App,$pParams,$1,$2);/emg;
	$text =~ s/\{\{(.*?::.*?)\}\}/eval("$1(" . '$this,$App,$pParams);');/emg;
	$text =~ s/\{\{(.*?\-\>.*?)\}\}/eval("$1(" . '$App,$pParams);');/emg;
use strict;

	$text =~ s/\n$//;

$charcode = $OriginalCode if(!defined $charcode);
#Jcode::convert(\$text, $charcode, "euc-jp") if($charcode ne '');
Jcode::convert(\$text, $charcode, $OriginalCode) if($charcode ne '' and $charcode ne $OriginalCode);

	return $text;
}

sub ExecuteSubroutine
{
	my ($App, $pParams, $s1, $s2) = @_;

	my $cmd = "$s1(" . '$App,$pParams,' . "$s2)";
#print "1: [$cmd]<br>\n";
	my $ret = eval($cmd);
	$ret = '' if($ret =~ /^-?\d$/);
	return $ret;
}

sub UpdatePage
{
	my ($this, $App, $pParams, $path) = @_;
	$pParams->{CurDir} = Utils::URLDecode($pParams->{CurDir});
	$pParams->{FileName} = Utils::URLDecode($pParams->{FileName});
	if(!defined $path) {
		$path = $pParams->{FileName};
#		$path =  Utils::URLDecode($pParams->{FileName});
#Jcode::convert(\$path, $pParams->{FileSystemCharCode});
		$path = $this->GetWikiPath($App, $pParams, $path);
#Jcode::convert(\$path, $pParams->{FileSystemCharCode});
#print "f: $path<br>\n";
	}
	return if(!defined $pParams->{FormText});

	my $LocalPath = $path;
	$App->PrintRawHTML("<b>FileName:</b> $LocalPath<br>\n");
#Jcode::convert(\$LocalPath, $pParams->{FileSystemCharCode});

Utils::ConvertHTMLSpecialCharacters($pParams->{FormText});
#my $SourceCharCode = Jcode::getcode($pParams->{FormText});
my $SourceCharCode = ($pParams->{WebCharCode} eq 'utf8')? 'utf-8' : $pParams->{WebCharCode};
#$App->print("S: $SourceCharCode\n");
Jcode::convert(\$pParams->{FormText}, $pParams->{FileSystemCharCode});#, $SourceCharCode);
$pParams->{FormText} =~ s/\r\n/\n/mg;
$pParams->{FormText} =~ s/\r/\n/mg;
#Sourceutf8asciiΤߤλʤȾѥڡ??˲ΤǤк
$pParams->{FormText} =~ s/\?\?/ /mg;
#$App->print($pParams->{FormText});
#return;

	my $out = new JFile($LocalPath, "w");
	if($out) {
		$out->print($pParams->{FormText});
		$out->Close();
		$App->H3("[$LocalPath] has been updated\n");
	}
	else {
		$App->H3("Error: Can not write to [$LocalPath]\n");
	}
}

sub EditPage
{
	my ($this, $App, $pParams, $path, $Action) = @_;
#	$pParams->{CurDir}   = $this->{WikiDir} if(!defined $pParams->{CurDir});
	$pParams->{CurDir}   = Utils::URLDecode($pParams->{CurDir});
	$pParams->{FileName} = Utils::URLDecode($pParams->{FileName});
	if(!defined $path) {
		$path = $this->GetWikiPath($App, $pParams, $pParams->{FileName});
	}
	$Action = "$this->{ModuleName}::UpdatePage" if(!defined $Action);

	$pParams->{WikiTextBoxWidth}  = 30 if(!defined $pParams->{WikiTextBoxWidth}  or $pParams->{WikiTextBoxWidth} <= 10);
	$pParams->{WikiTextBoxHeight} = 80 if(!defined $pParams->{WikiTextBoxHeight} or $pParams->{WikiTextBoxHeight} <= 5);

	my $LocalPath = $path;
Jcode::convert(\$LocalPath, $pParams->{FileSystemCharCode});
	$App->H3("Edit [$LocalPath]");
	my $FormText;
	$FormText = JFile->new()->ReadFile($LocalPath) if(-e $LocalPath);
	if(!defined $FormText) {
		if($FormText =~ /\.html?$/i) {
			$App->print("Template [$this->{HTMLTemplatePath}]\n");
			$FormText = JFile->new()->ReadFile($this->{HTMLTemplatePath});
		}
		else {
			$App->print("Template [$this->{WikiTemplatePath}]\n");
			$FormText = JFile->new()->ReadFile($this->{WikiTemplatePath});
		}
	}
Jcode::convert(\$FormText, $pParams->{WebCharCode});

	my $JS = new JSParams;
my $Debug = 0;
	if($path !~ /\.html?$/i) {
$App->print("not html\n") if($Debug);
		my $s = $JS->GetJSResizableString('.TextAreaText');
		$App->PrintRawHTML("$s\n");

Utils::InvalidateHTMLTags($FormText, 1, 1);
	}
	elsif($FormText =~ /\<TextArea/si) {
$App->print("html, but has TextArea\n") if($Debug);
		$App->H3("Warning in TkWiki::EditPage: The file contains 'TextArea' tag. Can not use TinyMCE editor.\n");
		my $s = $JS->GetJSResizableString('.TextAreaText');
		$App->PrintRawHTML("$s\n");

Utils::InvalidateHTMLTags($FormText, 1, 1);
	}
	else {
$App->print("html, not have TextArea: use TinyMCE\n") if($Debug);
		my $s = $JS->GetTinyMCEString('.TextAreaText', 
#				Language => $pParams->{Language},
#				Language => 'ja_utf-8',
				Language => 'en',
				Mode => 'exact',
				Elements => 'FormText',
				);
		$App->PrintRawHTML("$s\n");
	}

	my $HelpText;
	if($path =~ /\.htm?/i) {
		$HelpText = "
<H1>abc</H1>: Heading line (large)
<H2>abc</H2>: Heading line (large)
<H3>abc</H3>: Heading line (middle)
<H4>abc</H4>: Heading line (small)
<a href=\"URL\">abc</a>: Link to URL with the display label 'abc'
<b>abc</b>: Bold
<i>abc</i>: Italic\
<u>abc</u>: Underline
<strike>abc</strike>: Middle line
<sub>a</sub>: Subscript
<sup>a</sup>: Superscript
<font colro=\"#FF0000\">abc</font>: Color
<ul><li>item</li></ul>: Numbered items
<ol><li>item</li></ol>: Items
<table><tr><td></td></tr></table>: Table
<pre>abc</pre>: Formatted text
<!-- -->: comment
{abc}: Replaced with the internal parameter
<hr>: Horizontal bar
";
	}
	else {
		$HelpText = "
!!!: Heading line (large)
!!: Heading line (middle)
!: Heading line (small)
[abc|URL]: Link to URL with the display label 'abc'
'''abc''': Bold
''abc'': Italic\
__abc__: Underline
==abc==: Middle line
__a__: Subscript
^^a^^: Superscript
<red>abc</red>: Color
\\^: Escape a special character e.g. ^
+: Numbered items
++: Numbered items
+++: Numbered items
*: Items
**: Items
***: Items
,abc,ddb,dd: Table
  abc: Formatted text
//abc: comment
{abc}: Replaced with the internal parameter
{{Module::Func(args)}}: Plugin
{{\$App->{pMath}->exp(1.5)}}: Plugin
----: Horizontal bar
";
	}

	my $LocalPath = $pParams->{FileName};
#Jcode::convert(\$LocalPath, $pParams->{WebCharCode}); #$pParams->{FileSystemCharCode});
Jcode::convert(\$LocalPath, $pParams->{FileSystemCharCode});
$LocalPath = Utils::URLEncode($LocalPath);
	my $LocalCurDir = $pParams->{CurDir};
Jcode::convert(\$LocalCurDir, $pParams->{FileSystemCharCode});
$LocalCurDir = Utils::URLEncode($LocalCurDir);
	print <<EOT;
<table>
  <tr>
    <td>
<form method="POST" action="$pParams->{ScriptPath}" target="_self">
  <input type="submit" value="submit" name="B1"><br>
  <textarea rows="$pParams->{WikiTextBoxWidth}" name="FormText" cols="$pParams->{WikiTextBoxHeight}" class="TextAreaText">$FormText</textarea>
  <input type="hidden" name="Action" value="$Action">
  <input type="hidden" name="EMail" value="$pParams->{EMail}">
  <input type="hidden" name="Password" value="$pParams->{Password}">
  <input type="hidden" name="CurDir" value="$LocalCurDir">
  <input type="hidden" name="FileName" value="$LocalPath">
  <input type="hidden" name="Language" value="$pParams->{Language}">
  <input type="hidden" name="PrevAction" value="$pParams->{Action}">
  <input type="hidden" name="DBConfigName" value="$pParams->{DBConfigName}">
  <input type="hidden" name="ExtendedMenu" value="$pParams->{ExtendedMenu}">
  <input type="hidden" name="ShowAll" value="$pParams->{ShowAll}">
</form>
    </td>
    <td>
EOT

	$App->print($HelpText);
	print <<EOT;
    </td>
  </tr>
</table>
EOT
}

sub ViewPage
{
	my ($this, $App, $pParams, $path) = @_;

	my $TemplatePath = ($path)? $path : $this->GetWikiPath($App, $pParams, $pParams->{FileName});
Jcode::convert(\$TemplatePath, $pParams->{FileSystemCharCode});
#$App->print("Path: $TemplatePath\n");

	if($TemplatePath =~ /\.html?$/i) {
		my $text = Template->new()->GetTextByHash($TemplatePath, $pParams, '{', '}', 0, $pParams->{WebCharSet}, 1);
		$App->PrintRawHTML($text);
	}
	else {
		my $text = JFile->new()->ReadFile($TemplatePath);
		$text = $this->ConvertWikiPage($App, $pParams, $text, '');
#Jcode::convert(\$text, $pParams->{WebCharCode});
#$App->print($text);
		$App->PrintRawHTML($text);
	}
}

sub CreateFolder
{
	my ($this, $App, $pParams) = @_;

	my $LocalDir = $pParams->{DirectoryName};
Jcode::convert(\$LocalDir, $pParams->{FileSystemCharCode});
	my $path = $this->GetWikiPath($App, $pParams, $LocalDir);
	$App->PrintRawHTML("<b>CurDir:</b> $pParams->{CurDir}<br>\n");
	$App->PrintRawHTML("<b>DirectoryName:</b> $pParams->{DirectoryName}<br>\n");
	$App->PrintRawHTML("<b>path:</b> $path<br>\n");
	my $RootDirRegExp = Utils::RegExpQuote($this->{WikiDir});
	my $LinkPath = $path;
	$LinkPath =~ s/^$RootDirRegExp//;
	if(-d $path) {
		$App->PrintRawHTML("<H3>Folder [$path] already exists</H3>");
		$pParams->{CurDir} = $LinkPath;
		$pParams->{DirectoryName} = '';
	}
	elsif(Deps::CreateDirecotry($path)) {
		if(-d $path) {
			$App->PrintRawHTML("<H3>Folder [$path] has been created</H3>");
			$pParams->{CurDir} = $LinkPath;
			$pParams->{DirectoryName} = '';
		}
		else {
			$App->PrintRawHTML("<H3>Folder [$path] could not been created</H3>");
		}
	}
}

sub CreatePage
{
	my ($this, $App, $pParams) = @_;

	my $path = $this->GetWikiPath($App, $pParams, $pParams->{FileName});
	$App->PrintRawHTML("<b>FileName:</b> $pParams->{FileName}<br>\n");
	if(-e $path) {
		$App->H3("Error: Page [$path] exists. Use another name.");
		$App->HR();
		$this->ShowFilesPage($App, $pParams);
		return;
	}
}

sub FindFileRecursive
{
	my ($this, $App, $pParams, $dir, $fmask) = @_;
	
	my $pwd = getcwd();
	chdir($dir);
	my @f = glob('*');
	for(my $i = 0 ; $i < @f ; $i++) {
		$f[$i] = Utils::MakePath($dir, $f[$i], '/', 0);
	}
	chdir($pwd);
#	my $path = Utils::MakePath($dir, $fmask, '/', 0);
#	my @f = glob($path);
	my @files;
	foreach my $f (sort @f) {
		if(-d $f) {
			my @a = $this->FindFileRecursive($App, $pParams, $f, $fmask);
			push(@files, @a);
		}
		else {
			push(@files, $f);
		}
	}
	return @files;
}

sub IsPermitted
{
	my ($this, $App, $pParams, $Path) = @_;

	my $RootDirRegExp = Utils::RegExpQuote($this->{WikiDir});
	return $Path =~ /^$RootDirRegExp/i;
}

sub MakeDirLink
{
	my ($this, $App, $pParams, $dir, $label) = @_;

	my $BaseOption = $App->BuildCGIOption(
				{PrevAction => $pParams->{Action},},
				[qw(App EMail Password Language ShowAll ExtendedMenu PrevAction DBConfigName Year Month Day)],
				);

	my $RootDirRegExp = Utils::RegExpQuote($this->{WikiDir});
#$App->print("d: $dir : $RootDirRegExp\n");
	$dir =~ s/^$RootDirRegExp\/?//i;
	$dir = Utils::URLEncode($dir);
Jcode::convert(\$dir, $pParams->{WebCharCode});
	my $link = "$pParams->{ScriptPath}?Action=$this->{ModuleName}::ShowFilesPage&CurDir=$dir&$BaseOption";

#my $code = Jcode::getcode($label);
Jcode::convert(\$label, $pParams->{WebCharCode});
#my $code2 = Jcode::getcode($label);
#$App->print("L: $label [$code,$code2]\n");
	return "<a href=\"$link\" target=\"_self\"><b>$label</b></a>"
}

sub MakeDirTreeLink
{
	my ($this, $App, $pParams, $dir) = @_;

#Jcode::convert(\$dir, "euc-jp");
Jcode::convert(\$dir, "euc-jp", $pParams->{FileSystemCharCode});
	$dir =~ s/\\/\//g;
	my @a = Utils::Split("\\/", $dir);
Jcode::convert(\$dir, $pParams->{FileSystemCharCode}, "euc-jp");
for(my $i = 0 ; $i < @a ; $i++) {
	Jcode::convert(\$a[$i], $pParams->{FileSystemCharCode}, "euc-jp");
}
	my $Path = $a[0];
	if($Path =~ /:$/) {
		$Path .= "/";
	}
	else {
		$Path = "/$Path";
	}
	my $s = '';
	my $label = $Path;
	for(my $i = 0 ; $i < @a ; $i++) {
#$App->print("dir: $a[$i]\n");
		my ($IsPermitted, $BrowseDir, $FileRegExp, $DirRegExp, $ss, $st) = $this->IsPermitted($App, $pParams, $Path);
#$App->print("Path: $Path [$IsPermitted]\n");
		if(!$IsPermitted) {
			$Path  = Utils::MakePath($Path, $a[$i+1], '/', 0);
			$label = Utils::MakePath($label, $a[$i+1], '/', 0);
			next;
		}
		if(-d $Path) {
			$s .= '/' . $this->MakeDirLink($App, $pParams, $Path, $label);
		}
		elsif(-f $Path) {
			$s .= '/' . $this->MakeFileLink($App, $pParams, $Path, $label);
		}
		else {
		}
		$Path = Utils::MakePath($Path, $a[$i+1], '/', 0);
		$label = $a[$i+1];
	}
	$s =~ s/\///;
#Jcode::convert(\$s, $pParams->{WebCharCode});
	return $s;
}

sub ShowFilesPage
{
	my ($this, $App, $pParams, $ShowDirectory, $FindRecursive, $ShowTemplate, $ShowCreateDirectory, $ShowEditMenu, $ShowLink) = @_;
	$ShowDirectory = 0 if(!defined $ShowDirectory);
	$FindRecursive = 1 if(!defined $FindRecursive);
	$ShowTemplate  = 0 if(!defined $ShowTemplate);
	$ShowCreateDirectory  = 0 if(!defined $ShowCreateDirectory);
	$ShowEditMenu  = 1 if(!defined $ShowEditMenu);
	$ShowLink      = 1 if(!defined $ShowLink);

	if($pParams->{CurDir} eq '' and $pParams->{FileName} ne '') {
		my ($drive, $directory, $filename, $ext, $lastdir, $filebody) = Deps::SplitFilePath($pParams->{FileName});
		$pParams->{CurDir} = "$drive$directory";
		$pParams->{CurDir} =~ s/\\/\//g;
	}
my $LocalDir = $pParams->{CurDir};
Jcode::convert(\$LocalDir, $pParams->{FileSystemCharCode}) if(defined $pParams->{CurDir});
	my $CurDir = (defined $pParams->{CurDir})? Utils::MakePath($this->{WikiDir}, $LocalDir, '/', 0) : $this->{WikiDir};
	my $RootDirRegExp = Utils::RegExpQuote($this->{WikiDir});
	my $CurDirRegExp  = Utils::RegExpQuote($CurDir);
	my $LinkCurDir    = $CurDir;
#	$LinkCurDir = Utils::URLEncode($LinkCurDir);
	$LinkCurDir =~ s/^$RootDirRegExp//;
	$LinkCurDir = Utils::URLDecode($LinkCurDir);
	Jcode::convert(\$LinkCurDir, $pParams->{WebCharCode});
#$App->print("D: $LinkCurDir\n");
#$App->print("D: $this->{WikiDir}\n");

	my ($BaseOption, $target) = $App->GetCGIParameters(
				{PrevAction => $pParams->{Action},},
				[qw(+App EMail Password IsChildFrame FrameMode)],
				);

	my $fmask = Utils::MakePath($CurDir, "*", '/', 0);
	my $DirTreeLink = $this->MakeDirTreeLink($App, $pParams, $CurDir);
Jcode::convert(\$DirTreeLink, $pParams->{WebCharCode});

	if($ShowEditMenu) {
		$App->PrintRawHTML("<b><font size=\"3\">Browse [$DirTreeLink]</font></b><br>");

		my $CreateStr = $App->mlText('en' => 'Create Wiki Page', 'jp' => 'Wikiڡκ');
Jcode::convert(\$CreateStr, $pParams->{WebCharCode});
		my $LocalFile;
		if($pParams->{FileName}) {
			my ($drive, $directory, $filename, $ext1, $lastdir, $filebody) = Deps::SplitFilePath($pParams->{FileName});
			$LocalFile = $filename;
		}
Jcode::convert(\$LocalFile, $pParams->{WebCharCode});
#$App->print("LF[$LocalFile]\n");
		my $FormMessage = $App->mlText(
			'en' => "Extension should be .html for a usual HTML page and the other extensions are interpreted as a Wiki page.<br>"
			       ."For example, Your Name/Objective + Representative Date would be a good idea (e.g., Kamiya20081023).<br>",
			'jp' => "ĥҤ.htmlξ̾HTMLڡȤơ¾ξWikiڡȤưޤ<br>",
			);
Jcode::convert(\$FormMessage, $pParams->{WebCharCode});
		print <<EOT;
<form method="POST" action="$pParams->{ScriptPath}" target="_self">
<b><font color="#FF0000" size="3">$CreateStr</font>:</b> 
<input type="text" name="FileName" value="$LocalFile" size="20">
  <input type="submit" value="submit" name="B1">
<font size="1">$FormMessage</font>
  <input type="hidden" name="Action" value="$this->{ModuleName}::CreatePage">
  <input type="hidden" name="EMail" value="$pParams->{EMail}">
  <input type="hidden" name="Password" value="$pParams->{Password}">
  <input type="hidden" name="Language" value="$pParams->{Language}">
  <input type="hidden" name="CurDir" value="$LinkCurDir">
  <input type="hidden" name="PrevAction" value="$pParams->{Action}">
  <input type="hidden" name="DBConfigName" value="$pParams->{DBConfigName}">
  <input type="hidden" name="ExtendedMenu" value="$pParams->{ExtendedMenu}">
  <input type="hidden" name="ShowAll" value="$pParams->{ShowAll}">
</form>
EOT

		if($ShowCreateDirectory) {
			my $CreateStr = $App->mlText('en' => 'Create Folder', 'jp' => 'եκ');
Jcode::convert(\$CreateStr, $pParams->{WebCharCode});
			print <<EOT;
<form method="POST" action="$pParams->{ScriptPath}" target="_self">
<b><font color="#FF0000" size="3">$CreateStr</font>:</b> 
<input type="text" name="DirectoryName" value="$pParams->{DirectoryName}" size="20">
  <input type="submit" value="submit" name="B1"><br>
  <input type="hidden" name="Action" value="$this->{ModuleName}::CreateFolder">
  <input type="hidden" name="EMail" value="$pParams->{EMail}">
  <input type="hidden" name="Password" value="$pParams->{Password}">
  <input type="hidden" name="Language" value="$pParams->{Language}">
  <input type="hidden" name="CurDir" value="$LinkCurDir">
  <input type="hidden" name="PrevAction" value="$pParams->{Action}">
  <input type="hidden" name="DBConfigName" value="$pParams->{DBConfigName}">
  <input type="hidden" name="ExtendedMenu" value="$pParams->{ExtendedMenu}">
  <input type="hidden" name="ShowAll" value="$pParams->{ShowAll}">
</form>
EOT
		}
	}

	my $LinkStr = ($ShowLink)? "<td><b>Link</b></td>" : '';
#	my $FormStr = '';
	my $FormStr = $App->mlText('en' => 'Wiki pages: ', 'jp' => '¸Wikiڡ: ');
##Jcode::convert(\$FormStr, $pParams->{WebCharCode});
	if($ShowDirectory) {
		$App->PrintRawHTML("<b><font color=\"#FF0000\" size=\"3\">$FormStr</font></b> \n");
#Jcode::convert(\$DirTreeLink, $pParams->{WebCharCode}, $pParams->{FileSystemCharCode});
		$App->PrintRawHTML("$DirTreeLink<br><br>\n");
	}
	else {
		$App->PrintRawHTML("<H3><font color=\"#FF0000\">$FormStr</font></H3>");
	}

	print <<EOT;
<table border="1">
  <tr>
    <td><b>Wiki pages</b></td>
    <td><b>To do</b></td>
    <td><b>Path</b></td>
    $LinkStr
  </tr>
EOT

	my @files;
	if($FindRecursive) {
		@files = sort $this->FindFileRecursive($App, $pParams, $CurDir, "*");
	}
	else {
		my $pwd = getcwd();
		chdir($CurDir);
		@files = sort glob('*');
		for(my $i = 0 ; $i < @files ; $i++) {
			$files[$i] = Utils::MakePath($CurDir, $files[$i], '/', 0);
		}
		chdir($pwd);
#		@files = sort glob($fmask);
	}

	my $s = '';
	for(my $i = 0 ; $i < @files ; $i++) {
		my $path = $files[$i];
		$s .= Utils::URLDecode($path);
	}
my $SourceCharCode = Jcode::getcode($s);
#$App->H3("C: $SourceCharCode => $pParams->{WebCharCode}");

	for(my $i = 0 ; $i < @files ; $i++) {
		my $path = $files[$i];
		next unless($ShowDirectory and -d $path);
#		my ($drive, $directory, $filename, $ext, $lastdir, $filebody) = Deps::SplitFilePath($path);
		my $filename = $path;
		my $DisplayName = $path;
		$filename =~ s/^$RootDirRegExp\///i;
		if($FindRecursive) {
			$DisplayName =~ s/^$RootDirRegExp\///i;
		}
		else {
			$DisplayName =~ s/^$CurDirRegExp\///i;
		}
		$DisplayName = Utils::URLDecode($DisplayName);
if($^O ne 'MSWin32') {
Jcode::convert(\$DisplayName, $pParams->{WebCharCode}, $SourceCharCode);
}
#		my $dir = Utils::MakePath($CurDir, $path, '/', 0);
		my $LocalDir = Utils::URLEncode($DisplayName);
		my $link = "$pParams->{ScriptPath}?Action=$this->{ModuleName}::ShowFilesPage&CurDir=$LocalDir&$BaseOption";
		$App->PrintRawHTML("<tr>\n");
		$App->PrintRawHTML("  <td>[<a href=\"$link\" target=\"_self\"><b>$DisplayName</b></a>]</td>");
		$App->PrintRawHTML("  <td>\n");
		$App->PrintRawHTML("</tr>\n");
	}

	for(my $i = 0 ; $i < @files ; $i++) {
		my $path = $files[$i];
		next if(-d $path);
#		my ($drive, $directory, $filename, $ext, $lastdir, $filebody) = Deps::SplitFilePath($path);
		my $filename = $path;
		$filename =~ s/^$RootDirRegExp\///i;
		my $DisplayName = $path;
		if($FindRecursive) {
			$DisplayName =~ s/^$RootDirRegExp\///i;
		}
		else {
			$DisplayName =~ s/^$CurDirRegExp\///i;
		}
		$DisplayName = Utils::URLDecode($DisplayName);
if($^O ne 'MSWin32') {
Jcode::convert(\$DisplayName, $pParams->{WebCharCode}, $SourceCharCode);
}
#$App->print("f: $DisplayName\n");
		if($ShowTemplate) {
			next if($path !~ /\.html?$/i and $path !~ /\.txt$/i and $path !~ /\.wiki$/i and $path !~ /\.template$/i);
		}
		else {
			next if($path eq $this->{HTMLTemplatePath});
			next if($path eq $this->{WikiTemplatePath});
			next if($path !~ /\.html?$/i and $path !~ /\.txt$/i and $path !~ /\.wiki$/i);
		}
		next if($path =~ /_vt/i);
		next if($path =~ /NotUsed/i);

#$filename = Utils::URLDecode($filename);
		$filename = Utils::URLEncode($filename);
		$App->PrintRawHTML("<tr>\n");
		$App->PrintRawHTML("  <td><b><a href=\"$pParams->{ScriptPath}?Action=$this->{ModuleName}::ViewPage&FileName=$filename&$BaseOption\" "
						  ."target=\"_self\">$DisplayName</a></b></td>");
		$App->PrintRawHTML("  <td>\n");
		if($ShowEditMenu) {
			$App->PrintRawHTML("<a href=\"$pParams->{ScriptPath}?Action=$this->{ModuleName}::EditPage&FileName=$filename&$BaseOption\" "
					."target=\"_self\">Edit</a> ");
		}
		$App->PrintRawHTML("<a href=\"$pParams->{ScriptPath}?Action=$this->{ModuleName}::ViewPage&FileName=$filename&$BaseOption\" "
					."target=\"_self\">View</a> ");
		$App->PrintRawHTML("  </td>\n");
		$App->PrintRawHTML("  <td>");
		$path =~ s/\/([^\/]+)$/\/ $1/;
		$App->PrintRawHTML("<font size=\"1\">$path</font>\n");
		$App->PrintRawHTML("</td>\n");
		$App->PrintRawHTML("  <td>");
		my $URLHeader = $ENV{HTTP_REFERER};
		$URLHeader =~ s/^(.*?:\/\/.*?)(\/.*)$/$1/;
#		my $Option = "&EMail=$pParams->{EMail}&Password=$pParams->{Password}";
		my $Option = '';
		if($ShowLink) {
			my $link = "$URLHeader$pParams->{ScriptPath}?Action=$this->{ModuleName}::ViewPage&FileName=$filename$Option";
			$App->PrintRawHTML("<font size=\"1\"><a href=\"$link\" target=\"_blank\">$link</a></font>\n");
		}
		$App->PrintRawHTML("</td>\n");
		$App->PrintRawHTML("</tr>\n");
	}
	$App->PrintRawHTML("</table>\n");
}

1;
