import csv
import re

from tklib.tkutils import pint
from tklib.tkfile import tkFile
from tklib.tkinifile import tkIniFile
import tklib.tkre as tkre




class tkDataFile(tkFile):
    """ 
    tklib Data File class
    """

    def __init__(self, path = None, mode = 'r', OpenFile = True, **args):
        super().__init__(path = path, mode = mode, OpenFile = OpenFile, **args)
#        super(tkIniFile, self).__init__(path, mode, OpenFile, **args)

        self.labelarray    = []
        self.datalistarray = []

    def __del__(self):
        self.Close()
        super(tkIniFile, self).__del__()

    def __str__(self):
        return self.ClassPath()


    def GetArrayData(self, idx):
        pass
        """
	my $pLabelList = $this->LabelArray();
	my $pDataArray = $this->DataArray();
	my $nArray     = $this->nDataArray();
#	my $nData      = $this->nData();
#print "p=$pLabelList\n";
#print "p=$pDataArray\n";

	return undef if(!defined $pDataArray->[0]->[$idx]);
	my @array;
	for(my $i = 0 ; $i < $nArray ; $i++) {
		$array[$i] = $pDataArray->[$i]->[$idx];
	}
	return \@array;
        """

    def GetHashData(self):
        pass
        """
	my $pLabelList = $this->LabelArray();
	my $pDataArray = $this->DataArray();
	my $nArray     = $this->nDataArray();
#	my $nData      = $this->nData();
#print "p=$pLabelList\n";
#print "p=$pDataArray\n";

	return undef if(!defined $pDataArray->[0]->[$idx]);
	my %hash;
	for(my $i = 0 ; $i < $nArray ; $i++) {
		$hash{$pLabelList->[$i]} = $pDataArray->[$i]->[$idx];
	}
	return \%hash;
        """

    def FindLabelIndex(self, regexp, flag = ''):
#        print("labels=", self.labelarray)
#        print("reg=", regexp)
        if type(regexp) is int:
            return regexp
        else:
            try:
                return int(regexp)
            except:
                pass

        regexp_nosp = re.sub(r'[\[\(]', '(', regexp)
        regexp_nosp = re.sub(r'[\]\)]', ')', regexp_nosp)
        regexp_nosp = re.sub(r'\s', '', regexp_nosp)

        for i in range(len(self.labelarray)):
#            print("  i=", i, regexp, self.labelarray[i])
            if regexp == self.labelarray[i]:
                return i

            s_nosp = re.sub(r'[\[\(]', '(', self.labelarray[i])
            s_nosp = re.sub(r'[\]\)]', ')', s_nosp)
            s_nosp = re.sub(r'\s', '', s_nosp)
            if regexp_nosp == s_nosp:
                return i
            if tkre.Search(regexp, self.labelarray[i], flag):
                return i
        return None

    def FindDataArray(self, regexp, flag = ''):
#        print("labels=", self.labelarray)
#        print("data=", self.datalistarray)
        if type(regexp) is int:
            idx = regexp
        else:
            try:
                idx = int(regexp)
            except:
                idx = self.FindLabelIndex(regexp, flag)

        try:
            return self.labelarray[idx], self.datalistarray[idx]
        except:
            return None, None

 