@echo off

set BaseDir=d:\Programs
if not exist %BaseDir% (
	set BaseDir=c:\Programs
)
set tee=%BaseDir%\bin\ktee.exe -f

set TemplateDir=.\Template
set script=%TemplateDir%\CalElasticConstant.pl

set nStep=3
::mode: Cabc, CXYZ, V
set mode=V
set index=1111
:: fdiff = da / a, dV/V
set fdiff=0.01
::engine: gulp, vasp, pwscf
set engine=pwscf
::set engine=gulp
::set engine=vasp

set SampleName=%1
if "%SampleName%" == "" (
	set SampleName=Si
)
set Library=%2
if "%Library%" == "" (
	set Library=IGZO-Morse.lib
)

::Remove extension
set SampleName=%SampleName:.cif=%
set SampleName=%SampleName:.glp=%
set SampleName=%SampleName:.gin=%
set SampleName=%SampleName:.out=%
set SampleName=%SampleName:.axsf=%
set SampleName=%SampleName:.arc=%
set SampleName=%SampleName:.trg=%
set SampleName=%SampleName:.pre=%

@echo on

:perl %script% --Action=MakeInputs --Mode=%mode% --Index=%index% --nStep=%nStep% --fdiff=%fda% %SampleName%.cif | %tee% %SampleName%-input.out
perl %script% --Action=run       --Mode=%mode% --Index=%index% --Engine=%engine% ^
		--Library=%Library% SampleName%.cif | %tee% %SampleName%-run.out
:perl %script% --Action=cal        --Mode=%mode% --Index=%index% %SampleName%.cif | %tee% %SampleName%-cal.out

:END
