# Originaly written by He Xinyi
# Modified by T. Kamiya

import numpy
import matplotlib.pyplot as pyplt
from pymatgen.io.vasp.outputs import Vasprun
from pymatgen.electronic_structure.plotter import BSDOSPlotter, BSPlotter, BSPlotterProjected, DosPlotter

from tklib.tkapplication import tkApplication
from tklib.tkutils import terminate, pint, pfloat, getarg, getintarg, getfloatarg


vb_energy_range = 4.0
cb_energy_range = 4.0
egrid_interval  = 1
output_png_path = 'band.png'
save_figure = 1
plot_figure = 1

app    = tkApplication()
vb_energy_range = getfloatarg(1, vb_energy_range)
cb_energy_range = getfloatarg(2, cb_energy_range)
egrid_interval  = getintarg  (3, egrid_interval)
output_png_path = getintarg  (4, output_png_path)
save_figure     = getintarg  (5, save_figure)
plot_figure     = getintarg  (6, plot_figure)


dos_vasprun = Vasprun("./vasprun.xml")
dos_data    = dos_vasprun.complete_dos
bs_vasprun  = Vasprun("./vasprun.xml",parse_projected_eigen=True)
bs_data     = bs_vasprun.get_band_structure(line_mode=1)


plt = BSDOSPlotter(dos_projection = 'elements', bs_projection = 'elements')
plt.get_plot(bs = bs_data,dos = dos_data)


"""
plt = BSPlotterProjected(bs = bs_data)
plt.get_elt_projected_plots(zero_to_efermi = True, ylim = None, \
                                    vbm_cbm_marker = False)
"""

"""
plt = BSDOSPlotter(bs_projection = 'elements', dos_projection = None,
    #fig_size=(6, 8),
    vb_energy_range = vb_energy_range,
    cb_energy_range = cb_energy_range,
    egrid_interval = egrid_interval,
    bs_legend = 'best')

plt.get_plot(bs = bs_data, dos = None)
"""


if save_figure:
    pyplt.savefig('band.png')

if plot_figure:
    pyplt.pause(0.0001)

app.terminate(pause = True)

