#!/usr/bin/perl

BEGIN {
#use lib 'd:/Programs/Perl/lib';
#use lib '/home/tkamiya/bin/lib';
my $BaseDir = $ENV{'TkPerlDir'};
#print "\nBaseDir: $BaseDir\n";
@INC = ("$BaseDir/lib", "$BaseDir/VNL", "d:/Programs/Perl/lib", @INC);
}

use strict;
use Utils;
use JFile;
use CSV;

use Crystal::CIF;
use Crystal::Crystal;
use Crystal::VASP;
use Sci::Algorism;

my $Dir = ($ARGV[0] ne '')? $ARGV[0] : '.';
print "Dir: $Dir\n";

if(-d "Original") {
	print "Backup: Finished.\n";
}
if(-d "MD") {
	print "MD: Finished.\n";
}
if(-d "VCRelax1") {
	print "VCRelax Rough: Finished.\n";
}
if(-d "VCRelax") {
	print "VCRelax: Finished.\n";
}
if(-d "SCF") {
	print "SCF: Finished.\n";
}
if(-d "DOS") {
	print "DOS: Finished.\n";
}
my @dirs = sort glob("Band*");
for(my $i = 0 ; $i < @dirs ; $i++) {
	my $dir = $dirs[$i];
	next if(!-d $dir);
	print "$dir: Finished.\n";
}
if(-d "eDensity") {
	print "eDensity: Finished.\n";
}

my $INCAR = Deps::MakePath($Dir, "INCAR", 0);
#print "\nFrom INCAR\n";

print "============================================\n";
my $in = new JFile($INCAR, "r");
my $SYSTEM = $in->SkipTo("SYSTEM\\s*=");
print "SYSTEM: $SYSTEM\n";

print "============================================\n";
system("$ENV{HOME}/bin/Perl/Batch/remotecmd/convergence.sh");

print "============================================\n";
system("$ENV{HOME}/bin/Perl/Batch/remotecmd/summary.sh");
