#!/bin/bash

# Determine programs
TEE=$HOME/bin/ktee
MXDFileConv=$HOME/bin/MXDFileConv.exe
VASPDir=$TkPerlDir/VASP
VASPPL=$VASPDir/VASP.pl
export "CMD=/usr/bin/perl $VASPPL"

# Determine directories
WorkDir=
ARGDIR=`pwd`
ARG1=$ARGDIR/INCAR

# Common parameters
SpinPolarized=No
Precision=High
aKProduct=2.0
EDIFF=1.0e-4
EDIFFG=1.0e-3
ISMEAR=-5
SIGMA=0.03
DOSWidth=0.0

# VCRelax parameters
KeepSymmetry=1
PStress=0.0

# Band parameters
BandKPoints1=File
BandKPoints2=
BandKPoints3=
nKPoint=9

# DOS and eDensity parameters
nMesh=3000
MinEnergy=-15.0
MaxEnergy=15.0
AllSeparated=1

CommonParameters="--Precision=$Precision --Param:EDIFF=$EDIFF --Param:EDIFFG=$EDIFFG --Param:ISMEAR=$ISMEAR --Param:SIGMA=$SIGMA --SpinPolarized=$SpinPolarized --PStress=$PStress"

. $VASPDir/DoSCFDOS.shfunc
#. ./DoSCFDOS.shfunc

ReadArguments
MakeBackup Original

i=0
for a in 03.20 03.40 03.60 03.80 04.00 04.20 04.40 04.60 04.80 05.00 05.50 06.00 06.50 07.00 07.50 08.00 09.00 10.00 15.00
do
	if [ "$i" = "0" ]; then
		DoSCFDOS $a $a $a $a 90 90 90 1
		i=1
	else
		DoSCFDOS $a $a $a $a 90 90 90 0
	fi
done
