#!/usr/bin/perl
##!d:/Perl/bin/perl

BEGIN {
#use lib 'd:/Programs/Perl/lib';
#use lib '/home/tkamiya/bin/lib';
my $BaseDir = $ENV{'TkPerlDir'};
#print "\nBaseDir: $BaseDir\n";
@INC = ("$BaseDir/lib", "$BaseDir/VNL", "d:/Programs/Perl/lib", @INC);
}

use strict;
#use warnings;
#use CGI::Carp qw(fatalsToBrowser);
use Cwd;

use Deps;
use Utils;
use Crystal::AtomType;

BEGIN {
#	$| = 1;
	open (STDERR, ">&STDOUT");
}

#===============================================
# ϐ
#===============================================
my $ScriptCharCode = 'utf8';
my $FileSystemCharCode = 'sjis';

my $CSVFile = "TotalEnergy-metal-PBE.csv";
my $OutFile = "TotalEnergy-metal-PBE-graph.csv";


my $csv = new CSV;
$csv->Read($CSVFile, 0) or die "$!: Can not read [$CSVFile].\n";

my $pLabelArray = $csv->LabelArray();
my $pDataArray  = $csv->DataArray();
my $nData = $csv->nData();
print "nData: $nData\n";

#for(my $il = 0 ; $il < @$pLabelArray ; $il++) {
#	print "," if($il > 0);
#	print "$pLabelArray->[$il]";
#}
#print "\n";

my @d;
for(my $i = 0 ; $i < $nData ; $i++) {
	my $pHash = $csv->HashByIndex($i);
#	my ($a, $s) = ($pHash->{Compound} =~ /^([A-Z][a-z]?)\-([A-Za-z]+)/);
	my ($a, $s) = ($pHash->{Source} =~ /^([A-Z][a-z]?)\-([A-Za-z]+)/);
#	my ($a, $s) = ($pHash->{Compound}, 1);
	my $atnum = int(AtomType::GetAtomicNumber($a) + 0.001);
	$d[$atnum]{Atom}        = $a;
	if($pHash->{Etot} == 0.0) {
		$d[$atnum]{$s}{Etot}    = 1.0e10;
		$d[$atnum]{$s}{Density} = 0;
	}
	else {
		$d[$atnum]{$s}{Etot}    = $pHash->{Etot} / $pHash->{Z};
		$d[$atnum]{$s}{Density} = $pHash->{Density};
	}

	print "i=$i: $pHash->{Source}: $a [$atnum]: $s: E=$d[$atnum]{$s}{Etot}: d=$d[$atnum]{$s}{Density}\n";
}

open(OUT, ">$OutFile") or die "$!: Can not write to [$OutFile].\n";
print OUT "Atom,StableStructure,FCC,BCC,HCP,SC,Diamond,d(FCC),d(BCC),d(HCP),d(SC),d(Diamond)\n";
for(my $i = 0 ; $i < @d ; $i++) {
	my $p = $d[$i];
	next if(!defined $p);

	$p->{FCC}{Etot}     = 1.0e10 if($p->{FCC}{Etot} == 0.0);
	$p->{BCC}{Etot}     = 1.0e10 if($p->{FCC}{Etot} == 0.0);
	$p->{HCP}{Etot}     = 1.0e10 if($p->{FCC}{Etot} == 0.0);
	$p->{SC}{Etot}      = 1.0e10 if($p->{FCC}{Etot} == 0.0);
	$p->{Diamond}{Etot} = 1.0e10 if($p->{FCC}{Etot} == 0.0);

	my ($mins, $minE) = ('', 1.0e100);
	($mins, $minE) = ("FCC",     $p->{FCC}{Etot})     if($minE > $p->{FCC}{Etot});
	($mins, $minE) = ("BCC",     $p->{BCC}{Etot})     if($minE > $p->{BCC}{Etot});
	($mins, $minE) = ("HCP",     $p->{HCP}{Etot})     if($minE > $p->{HCP}{Etot});
	($mins, $minE) = ("SC",      $p->{SC}{Etot})      if($minE > $p->{SC}{Etot});
	($mins, $minE) = ("Diamond", $p->{Diamond}{Etot}) if($minE > $p->{Diamond}{Etot});

	print "i=$i: $p->{Atom}: $mins\n";
	print OUT "$p->{Atom},$mins,", 
				$p->{FCC}{Etot}-$minE, ",", $p->{BCC}{Etot}-$minE, ",", $p->{HCP}{Etot}-$minE, ",", 
				$p->{SC}{Etot}-$minE,  ",", $p->{Diamond}{Etot}-$minE, ",",
				$p->{FCC}{Density}, ",", $p->{BCC}{Density}, ",", $p->{HCP}{Density}, ",", 
				$p->{SC}{Density},  ",", $p->{Diamond}{Density},
				"\n";
}
close(OUT);

exit;
