#!/bin/bash

VASPDir=$TkPerlDir/VASP
CMD="/usr/bin/perl $VASPDir/VASP.pl"

TemplateDir=Original

iSite=$1
x=$2
y=$3
post=$4
DebugMode=0

WorkDir=$x$y$post

#================================
# Copy to symmetry position 1
#================================
xs=`expr $y`
ys=`expr $x`
xs=`printf "%02d" $xs`
ys=`printf "%02d" $ys`
ddir=$xs$ys$post
if [ -d $ddir ]; then
	echo "[Copy]: [$ddir] exists. Skip."
else
	echo Copy [$WorkDir] to [$ddir]
	cp -r $WorkDir $ddir
	if [ -f "$ddir/SCF/POSCAR" ]; then
		$CMD --Action=ModifyPOSCAR --Positions=$iSite:x:0.$xs\;$iSite:y:0.$ys $ddir/SCF/POSCAR
	fi
fi

#================================
# Copy to symmetry position 2
#================================
xs=`expr 50 - $x`
ys=`expr 50 - $y`
xs=`printf "%02d" $xs`
ys=`printf "%02d" $ys`
ddir=$xs$ys$post
if [ -d $ddir ]; then
	echo "[Copy]: [$ddir] exists. Skip."
else
	echo Copy [$WorkDir] to [$ddir]

	cp -r $WorkDir $ddir
	if [ -f "$ddir/SCF/POSCAR" ]; then
	$CMD --Action=ModifyPOSCAR --Positions=$iSite:x:0.$xs\;$iSite:y:0.$ys $ddir/SCF/POSCAR
	fi
fi

#================================
# Copy to symmetry position 3
#================================
xs=`expr 50 - $y`
ys=`expr 50 - $x`
xs=`printf "%02d" $xs`
ys=`printf "%02d" $ys`
ddir=$xs$ys$post
if [ -d $ddir ]; then
	echo "[Copy]: [$ddir] exists. Skip."
else
	echo Copy [$WorkDir] to [$ddir]

	cp -r $WorkDir $ddir
	if [ -f "$ddir/SCF/POSCAR" ]; then
		$CMD --Action=ModifyPOSCAR --Positions=$iSite:x:0.$xs\;$iSite:y:0.$ys $ddir/SCF/POSCAR
	fi
fi
