#!/bin/bash

VASPDir=$TkPerlDir/VASP
CMD="/usr/bin/perl $VASPDir/VASP.pl"

UseCalculatedPOSCAR=$1
SCRIPTDir=$2
TemplateDir=$3
xarray=($4)
y=$5
iSite=$6
post=$7
DebugMode=0

nx=${#xarray[@]}

if [ "$UseCalculatedPOSCAR" = "" ]; then
	echo UseCalculatedPOSCAR is not specified.
	echo usage: CalcLineX.sh UseCalculatedPOSCAR iSite y
	exit 0
fi
if [ "$iSite" = "" ]; then
	echo iSite is not specified.
	echo usage: CalcLineX.sh UseCalculatedPOSCAR iSite y
	exit 0
fi
if [ "$y" = "" ]; then
	echo y is not specified.
	echo usage: CalcLineX.sh UseCalculatedPOSCAR iSite y
	exit 0
fi

for ((ix = 0; ix < $nx; ix++)) {
	ixm1=`expr $ix - 1`
	x=${xarray[$ix]}

#================================
# Main calculation
#================================
	WorkDir=$x$y$post
	if [ -d $WorkDir ]; then
		echo "[Work]: [$WorkDir] exists. Skip."
	else
		echo Work for [$WorkDir]

# Copy the final POSCAR to WorkDir
		if [ "$UseCalculatedPOSCAR" = "1" ]; then
			SourcePOSCAR=${xarray[$ixm1]}$y$post/VCRelax/POSCAR
			if [ -f "$SourcePOSCAR" ]; then
				cp $SourcePOSCAR $TemplateDir
			fi
		fi

# Execute VASP
		$SCRIPTDir/CalcOne.sh $SCRIPTDir $TemplateDir $iSite $x $y $post
	fi
}

exit 1
