#!/bin/bash

#============================
# Global parameters
#============================
nCPU=16

VASPCommand="mpirun -np $nCPU `which vasp_std`"
# echo VC:[$VASPCommand]


SCRIPTDir=$TkPerlDir/VASP/script
VASPDir=$TkPerlDir/VASP
VASPCMD="/usr/bin/perl $VASPDir/VASP.pl"


BaseDir=`pwd`

OriginalDir=$BaseDir
TemplateDir=$BaseDir/template
SourceDir=$BaseDir/source

FileList=$SourceDir/anharm*.POSCAR


#===========================
# Perform ConvergedDFT.sh
#===========================

#ls $FileList


for FullPath in $FileList
do
	FileName=${FullPath#$SourceDir/}
	Header=${FileName%.POSCAR}

	WorkDir=$Header

	echo "Working for POSCAR [$FullPath]"
	echo "  POSCAR file: [$FileName]"
	echo "  Create dir [$WorkDir]"

	if [ -d $WorkDir ]; then
		echo
		echo "   Warning: Work dir [$WorkDir] exists."
		echo "   Skip."
		echo
	else
		mkdir $WorkDir
		if [ -d $WorkDir ]; then
			echo "   Succeeded: Create dir [$WorkDir]"
		else
			echo 
			echo "Error: Failed to create dir [$WorkDir]"
			echo

			exit
		fi

		echo "  Execute [cp $TemplateDir/* $WorkDir]"
		cp $FullPath $WorkDir/POSCAR
		echo "  Execute [cp $TemplateDir/* $WorkDir]"
		cp $TemplateDir/* $WorkDir
		echo "  Execute [cp $FullPath $WorkDir/POSCAR]"
		cp $FullPath $WorkDir/POSCAR

		echo "  [cd $WorkDir]"
		cd $WorkDir
		echo "  Execute [$VASPCommand]"
#		$VASPCommand

		echo ''
		echo === Exit to \"$OriginalDir\"
		cd $OriginalDir
	fi
	
	echo ''
	echo ''

	PrevDir=$WorkDir
done


#===========================
# Post processors
#===========================
