#!/bin/bash

SCRIPTDir=`pwd`/script
VASPDir=$TkPerlDir/VASP
CMD="/usr/bin/perl $VASPDir/VASP.pl"

TemplateDir=Original
TemplateSymDir=Original.sym
RelaxedSymPOSCAR=$TemplateSymDir/POSCAR.relaxed

iSite=16
AtomType=Se
xarray="25 20 15 10 05 00"
yarray="25 20 15 10 05 00"
yForLine=00
post=

cp $TemplateSymDir/POSCAR $TemplateDir

#===========================
# Calculate symmetry lines
#===========================
if [ -f $RelaxedSymPOSCAR ]; then
	cp $RelaxedSymPOSCAR $TemplateDir/POSCAR
fi
$SCRIPTDir/CalcDiagonal2.sh 1 $SCRIPTDir "$xarray" $iSite $post

#===========================
# Post processors
#===========================
$SCRIPTDir/MergePositionsInCIFs.pl --Positions=$iSite 2525/SCF MergedCIF.cif
$SCRIPTDir/MakeSummaryCSV2.pl --Positions=$iSite --AtomType=$AtomType
