#!/bin/bash
# use -x option for debug

. $DataRoot/scripts/vasp_config.sh


#====================================================
# Initialization
#====================================================
ThisScript=$0
BaseDir=`pwd`
OriginalDir=$BaseDir
WorkDir= 
ARGDIR=$BaseDir

DOSWidth=0.03

if [ "$1" != "" ]; then
	DOSWidth=$1
fi

#====================================
# DFTSCF
#====================================
echo 
echo ======================================================================
echo Execute [$CMD --Action=MakeDOSCSV --Width=$DOSWidth --IgnoreZero=0 DOSCAR DOS-up.csv DOS-dn.csv]
echo ======================================================================
$CMD --Action=MakeDOSCSV --Width=$DOSWidth --IgnoreZero=0 DOSCAR DOS-up.csv DOS-dn.csv

echo 
echo ======================================================================
echo Execute [perl $VASPLDCMD --Action=MakeInput . ]
echo ======================================================================
$VASPLDCMD --Action=MakeInput . 
echo ======================================================================
echo "Execute $EnergyPath < LDEnergy.dat | $TEE LDEnergy.out"
echo ======================================================================
$EnergyPath < LDEnergy.dat | $TEE LDEnergy.out

if [ -f $BaderCMD -a -f "AECCAR0" -a -f "AECCAR2" ]; then
	echo 
	echo ======================================================================
	echo Execute [$CMD --Action=AddCharges AECCAR0 AECCAR2 CHGCAR_sum]
	echo ======================================================================
	$CMD --Action=AddCharges AECCAR0 AECCAR2 CHGCAR_sum
	$BaderCMD CHGCAR -ref CHGCAR_sum
	$CMD --Action=SummarizeBader --kVolume=$UpdateRWIGsByRBader . ACF.dat AVF.dat BCF.dat Bader.out
fi

#if [ "$UpdateRWIGsByRBader" != "" ]; then
#	$CMD --Action=UpdateRWIGsByRBader . Bader.out
#	cp INCAR INCAR.original
#fi

echo ' '
echo '================================================================'
echo "  Make summary"
echo '================================================================'
#echo
#echo == Execute [$VASPScriptDir/Summarize2.pl ./ \> Summarize.txt]
#perl $VASPScriptDir/Summarize2.pl ./ > Summarize.txt
#echo
#echo == Execute [$VASPScriptDir/Summarize.pl  ./ \> Summarize-SpinPolarized.txt]
#perl $VASPScriptDir/Summarize.pl  ./ > Summarize-SpinPolarized.txt
echo
echo == Execute [$VASPScriptDir/MakeSummaryHTML.pl]
perl $VASPScriptDir/MakeSummaryHTML.pl

echo 
echo ======================================================================
echo $0 finished.
echo ======================================================================
echo 
