#!/bin/bash
# use -x option for debug

HostName=`hostname`

#==========================================
# Define programs: Usually no need to edit
#==========================================
export PerlPath=perl
export PythonPath=python

export TkProgramsDir=$DataRoot
export TkProgramsBinDir=$DataRoot/bin

export MyAppDir=$DataRoot/bin
export BaderDir=$MyAppDir/Bader
export LDDir=$MyAppDir/LD
export RamanSCDir=$MyAppDir/raman-sc
export BaderCMD="$BaderDir/bader"
export EnergyPath=$LDDir/energy

export VASPDir=$TkPerlDir/VASP
export VASPScriptDir=$VASPDir/script

export CMD="$PerlPath $VASPDir/VASP.pl"
export VASPFSCMD="$PerlPATH $VASPDir/VASPFS.pl"
export VASPLDCMD="$PerlPATH $VASPDir/VASPLD.pl"

export "PHONOPYplCMD=$PerlPATH $VASPDir/Phonopy.pl"
export "WIEN2kplCMD=$PerlPATH $TkPerlDir/WIEN2k/WIEN2k.pl"

export MakeCIFCMD="$CMD --Action=ConvCONTCARFiles"
export MakeXSFCMD="$CMD --Action=MakeRelaxXSFFile --kMagnetization=0.8 --ArrowColor=255:0:0 --ArrowRadius=0.2"
export MakeSymmetrizedCIFCMD="$WIEN2kplCMD --Action=MakeSymmetrizedStructFile --TOL=0.001 *-final.cif out.struct"

export CalIRCMD=$VASPScriptDir/CalIR.sh
export CalRamanCMD=$RamanSCDir/vasp_raman.py
export DoPhonopyTemplatePath=$VASPScriptDir/DoPhonopy-Template20180418.sh
export DoPhonopyCMD=DoPhonopy.sh

#====================================================
# Initialization: No need to edit
#====================================================
ThisScript=$0
BaseDir=`pwd`
OriginalDir=$BaseDir
WorkDir= 
ARGDIR=$BaseDir

DOSWidth=0.03

if [ "$1" != "" ]; then
	DOSWidth=$1
fi

#====================================
# DFTSCF
#====================================
$CMD --Action=MakeDOSCSV --Width=$DOSWidth --IgnoreZero=0 DOSCAR DOS-up.csv DOS-dn.csv

#if [ "$CalLDEnergyForDOS" = "1" ]; then
#	$VASPLDCMD --Action=MakeInput . 
#	$EnergyPath < LDEnergy.dat | $TEE LDEnergy.out
#fi

#if [ -f $BaderCMD -a -f "AECCAR0" -a -f "AECCAR2" ]; then
#	$CMD --Action=AddCharges AECCAR0 AECCAR2 CHGCAR_sum
#	$BaderCMD CHGCAR -ref CHGCAR_sum
#	$CMD --Action=SummarizeBader --kVolume=$UpdateRWIGsByRBader . ACF.dat AVF.dat BCF.dat Bader.out
#fi

#if [ "$UpdateRWIGsByRBader" != "" ]; then
#	$CMD --Action=UpdateRWIGsByRBader . Bader.out
#	cp INCAR INCAR.original
#fi

perl $VASPScriptDir/MakeSummaryHTML.pl
