#!/bin/bash
# use -x option for debug

HostName=`hostname`

#==========================================
# Define programs
#==========================================
export TEE=tee
export PerlPath=perl
export PythonPath=python
export Python2Path=/usr/bin/python

export TkProgramsDir=$DataRoot
export TkProgramsBinDir=$DataRoot/bin

export MyAppDir=$DataRoot/bin
export BaderDir=$MyAppDir/Bader
export LDDir=$MYAPPDIR/LD
export RamanSCDir=$MYAPPDIR/raman-sc
export BaderCMD=$BaderDir/bader
export EnergyPath=$LDDir/energy

export VASPDir=$TkPerlDir/VASP
export VASPScriptDir=$VASPDir/script
export CMD="$PerlPath $VASPDir/VASP.pl"
export MakeCIFCMD="$CMD --Action=ConvCONTCARFiles"
export MakeXSFCMD="$CMD --Action=MakeRelaxXSFFile --kMagnetization=0.8 --ArrowColor=255:0:0 --ArrowRadius=0.2"
export VASPFSCMD="$PerlPATH $VASPDir/VASPFS.pl"
export VASPLDCMD="$PerlPATH $VASPDir/VASPLD.pl"

export PHONOPYplCMD="$PerlPATH $VASPDir/Phonopy.pl"
export DoPhonopyTemplatePath=$VASPScriptDir/DoPhonopy-Template20180418.sh
export DoPhonopyCMD=DoPhonopy.sh

export WIENROOT=$TkProgramsBinDir/wien12
export WIEN2kplCMD="$PerlPATH $TkPerlDir/WIEN2k/WIEN2k.pl"
export MakeSymmetrizedCIFCMD="$WIEN2kplCMD --Action=MakeSymmetrizedStructFile --TOL=0.001 *-final.cif out.struct"

export CalIRCMD=$VASPScriptDir/CalIR.sh
export CalRamanCMD="$Python2Path $RamanSCDir/vasp_raman.py"


#====================================================
# Initialization
#====================================================
export ThisScript=$0
export BaseDir=`pwd`
export OriginalDir=$BaseDir
export ARGDIR=$BaseDir
export ARG1=$ARGDIR/INCAR
export Action=$1
export Arg1=$2
export Arg2=$3
export Arg3=$4
export Arg4=$5
