#!/usr/bin/perl

use strict;
use lib 'd:/Programs/Perl/lib';
use lib 'c:/programs/perl/lib/';

use Utils;

my $InFile  = "101109-3rd#41LaCo2B2.txt";
my $OutFile = "101109-3rd#41LaCo2B2.int";

open(IN,  $InFile)     or die "Error: Can not read [$InFile]: $!\n";
open(OUT, ">$OutFile") or die "Error: Can not write to [$OutFile]: $!\n";
while(1) {
	my $line = <IN>;
	last if($line =~ /YCounts/);
}
my $c = 0;
my (@x, @y);
while(!eof(IN)) {
	my $line = <IN>;
	my @a = Utils::Split("\\s+", $line);
	last if(@a < 2);

	$x[$c] = $a[0];
	$y[$c] = $a[1];
	$c++;
}
my $nData = $c;
my $Qmin  = $x[0];
my $Qmax  = $x[$nData-1];
my $Qstep = ($Qmax - $Qmin) / ($nData-1);
print "nData=$nData\n";
print "Q range: $Qmin - $Qmax, $Qstep\n";

print OUT "GENERAL\n";
print OUT " $nData\n";
for(my $i = 0 ; $i < $nData ; $i++) {
	my $Q = $Qmin + $i * $Qstep;
	my $I = int($y[$i] + 0.5);
	print OUT " $Q     $I\n";
}

close(OUT);
close(IN);
exit;


